/*!
 * System Runtime
 * 
 * https://designfirst.io/systemruntime/
 * 
 * Copyright 2024 Erwan Carriou
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
!function(e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define([],e):("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).runtime=e()}(function(){var define,module,exports;return function a(r,o,i){function s(t,e){if(!o[t]){if(!r[t]){var n="function"==typeof require&&require;if(!e&&n)return n(t,!0);if(d)return d(t,!0);throw(e=new Error("Cannot find module '"+t+"'")).code="MODULE_NOT_FOUND",e}n=o[t]={exports:{}},r[t][0].call(n.exports,function(e){return s(r[t][1][e]||e)},n,n.exports,a,r,o,i)}return o[t].exports}for(var d="function"==typeof require&&require,e=0;e<i.length;e++)s(i[e]);return s}({1:[function(e,t,n){"use strict";n.system={name:"system-runtime",master:!1,version:"5.3.0",description:"System Runtime",schemas:{"1ac07185641fa9f":{_name:"_Behavior",_inherit:["_Component"],_core:!0,core:"property",component:"property",action:"property",state:"property",useCoreAPI:"property",context:"property",_id:"1ac07185641fa9f"},"104ad1f48518376":{_id:"104ad1f48518376",_name:"_Channel",_inherit:["_Component"],_core:!0,send:"event",$systemInstalled:"event",$systemResolved:"event",$systemStarted:"event",$systemStopped:"event",$systemUninstalled:"event"},"111df11e2b19fde":{_id:"111df11e2b19fde",_name:"_Component",_inherit:[],_core:!0,on:"method",off:"method",require:"method",destroy:"method",init:"method",error:"event"},"1723516a30132ac":{_name:"_Database",_inherit:["_Component"],_core:!0,collections:"method",insert:"event",update:"event",remove:"event",_id:"1723516a30132ac"},"1268f1dddd1fea7":{_name:"_Logger",_core:!0,level:"property",debug:"method",info:"method",warn:"method",error:"method",_id:"1268f1dddd1fea7"},"14caa1c46414ee1":{_name:"_Message",_inherit:["_Component"],_core:!0,event:"property",from:"property",data:"property",_id:"14caa1c46414ee1"},"193f1166eb16609":{_name:"_Metamodel",_inherit:["_Component"],_core:!0,schema:"method",model:"method",type:"method",create:"method",_id:"193f1166eb16609"},"157931f7a31b61d":{_id:"157931f7a31b61d",_name:"_OSGi",_inherit:["_Component"],_core:!0,install:"method",uninstall:"method",start:"method",stop:"method",status:"method",bundle:"method"},"12e211d4cd120a6":{_id:"12e211d4cd120a6",_name:"_Runtime",_inherit:["_OSGi"],_core:!0,version:"property",system:"method",message:"method",ready:"event"},"1cb761fa4510dca":{_id:"1cb761fa4510dca",_name:"_System",_inherit:["_SystemOSGi"],_core:!0,name:"property",master:"property",version:"property",description:"property",schemas:"property",models:"property",behaviors:"property",types:"property",components:"property"},"145fe10c7514298":{_id:"145fe10c7514298",_name:"_SystemOSGi",_inherit:["_Component"],_core:!0,state:"property",location:"property",start:"method",stop:"method"},"e018483e-4254-455c-83e9-99bb8dc3b233":{_id:"e018483e-4254-455c-83e9-99bb8dc3b233",_name:"_History",_core:!0,_inherit:["_Component"],back:"method",forward:"method",from:"method",dump:"method",get:"method",load:"method",start:"method",stop:"method",clear:"method"}},models:{"166971fd9d107fd":{_name:"_Behavior",_core:!0,context:{type:"any",readOnly:!1,mandatory:!1,default:null},core:{type:"boolean",readOnly:!1,mandatory:!1,default:!1},useCoreAPI:{type:"any",readOnly:!1,mandatory:!1,default:!1},component:{type:"string",readOnly:!1,mandatory:!0,default:""},action:{type:"javascript",readOnly:!1,mandatory:!0,default:""},state:{type:"string",readOnly:!1,mandatory:!0,default:""},_id:"166971fd9d107fd"},"135c71078810af2":{_id:"135c71078810af2",_name:"_Channel",_core:!0,send:{params:[{name:"message",type:"message"}]},$systemInstalled:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},$systemResolved:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},$systemUninstalled:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},$systemStarted:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},$systemStopped:{params:[{name:"id",type:"string",mandatory:!0,default:""}]}},"123751cb591de26":{_id:"123751cb591de26",_name:"_Component",_core:!0,on:{params:[{name:"state",type:"string"},{name:"action",type:"function"},{name:"useCoreAPI",type:"any",mandatory:!1,default:!1},{name:"isCore",type:"boolean",mandatory:!1,default:!1}]},off:{params:[{name:"state",type:"string",mandatory:!1},{name:"behaviorId",type:"string",mandatory:!1}]},require:{params:[{name:"id",type:"string"}]},destroy:{params:[]},init:{params:[{name:"document",type:"object"}]},error:{params:[{name:"e",type:"errorInfo"}]}},"18a51169d7112d4":{_name:"_Database",_core:!0,collections:{result:"object"},insert:{params:[{name:"event",type:"dbInsertEvent"}]},update:{params:[{name:"event",type:"dbUpdateEvent"}]},remove:{params:[{name:"event",type:"dbRemoveEvent"}]},_id:"18a51169d7112d4"},"16b9d1ac2216ffe":{_id:"16b9d1ac2216ffe",_name:"_Logger",_core:!0,level:{type:"log",readOnly:!1,mandatory:!1,default:"warn"},debug:{params:[{name:"message",type:"any"}]},info:{params:[{name:"message",type:"any"}]},warn:{params:[{name:"message",type:"any"}]},error:{params:[{name:"message",type:"any"}]}},"1d9b6139411aa91":{_name:"_Message",_core:!0,event:{type:"string",readOnly:!1,mandatory:!0,default:""},from:{type:"string",readOnly:!1,mandatory:!0,default:""},data:{type:"array",readOnly:!1,mandatory:!0,default:[]},_id:"1d9b6139411aa91"},"1628c13c22152e6":{_name:"_Metamodel",_core:!0,schema:{params:[{name:"name",type:"any",default:"",mandatory:!1},{name:"schema",type:"object",default:{},mandatory:!1}],result:"any"},model:{params:[{name:"name",type:"any",default:"",mandatory:!1},{name:"model",type:"object",default:{},mandatory:!1}],result:"any"},type:{params:[{name:"name",type:"any",default:"",mandatory:!1},{name:"type",type:"object",default:{},mandatory:!1}],result:"any"},create:{params:[]},_id:"1628c13c22152e6"},"100b91ed2211b15":{_id:"100b91ed2211b15",_name:"_OSGi",install:{params:[{name:"url",type:"any",mandatory:!0,default:""},{name:"async",type:"boolean",mandatory:!1,default:!0}],result:"string"},uninstall:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},start:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},stop:{params:[{name:"id",type:"string",mandatory:!0,default:""}]},status:{result:"object"},_core:!0,bundle:{result:"string"}},"14c7c105b31a160":{_id:"14c7c105b31a160",_name:"_Runtime",_core:!0,version:{type:"string",readOnly:!0,mandatory:!0,default:"5.3.0"},system:{params:[{name:"params",type:"any",mandatory:!1}],result:"object"},message:{params:[{name:"msg",type:"message",mandatory:!0}]},ready:{}},"170521b88614387":{_name:"_System",_core:!0,name:{type:"string",readOnly:!1,mandatory:!0,default:""},master:{type:"boolean",readOnly:!1,mandatory:!1,default:!1},version:{type:"string",readOnly:!1,mandatory:!1,default:"0.0.1"},description:{type:"string",readOnly:!1,mandatory:!1,default:""},schemas:{type:"object",readOnly:!1,mandatory:!1,default:{}},models:{type:"object",readOnly:!1,mandatory:!1,default:{}},behaviors:{type:"object",readOnly:!1,mandatory:!1,default:{}},types:{type:"object",readOnly:!1,mandatory:!1,default:{}},components:{type:"object",readOnly:!1,mandatory:!1,default:{}},_id:"170521b88614387"},"1b2811b092143f5":{_id:"1b2811b092143f5",_name:"_SystemOSGi",start:{},stop:{},_core:!0,state:{type:"string",readOnly:!1,mandatory:!1,default:"none"},location:{type:"string",readOnly:!1,mandatory:!1,default:""}},"bd8d7e02-cd1f-4e4e-857f-077d6425cc1a":{_id:"bd8d7e02-cd1f-4e4e-857f-077d6425cc1a",_name:"_History",_description:"",back:{result:"number"},forward:{result:"number"},dump:{result:"string"},_core:!0,from:{params:[{name:"index",type:"number",mandatory:!0,default:-1}],result:"any"},get:{params:[{name:"index",type:"number",mandatory:!0,default:-1}],result:"object"},load:{params:[{name:"dump",type:"any",mandatory:!0,default:""}],result:"boolean"},start:{result:"any"},stop:{result:"any"},clear:{result:"any"}}},behaviors:{"12e491859c13918":{_id:"12e491859c13918",component:"_Channel",state:"$systemStarted",action:"function $systemStarted(id) { \n  var systems = null;\n    \n  if (id !== 'e89c617b6b15d24') {\n    if (typeof document !== 'undefined') {\n      systems = document.querySelectorAll('link[rel=system]');\n         \n      if ($state.get('runtime') && $state.get('runtime').state === 'ready') {    \n      } else {\n        if (systems.length + 1 === $db._System.count()) {\n          $component.get('runtime').ready();\n        }\n      }\n    }\n  }\n}",useCoreAPI:!0,core:!0},"1e9021bd4e1bc6e":{_id:"1e9021bd4e1bc6e",component:"_Channel",state:"$systemInstalled",action:"function $systemInstalled(id) {\n  var systems = null,\n    dependencies = [],\n    master = [],\n    canStart = true;\n\n  if (id !== 'e89c617b6b15d24') {\n    // if all systems are installed\n    systems = $db._System.find({});\n\n    systems.forEach(function (system) {\n      var sys = this.require(system._id);\n      if (sys && sys.state && sys.state() === 'none') {\n        canStart = false;\n      }\n    }.bind(this));\n\n    // start all the systems\n    if (canStart) {\n      dependencies = $db._System.find({\n        'master': false\n      });\n\n      dependencies.forEach(function (dep) {\n        var system = this.require(dep._id);\n        channel = this.require('channel');\n\n        if (system.state() === 'resolved') {\n          system.state('starting');\n          system.start();\n          channel.$systemStarted(dep._id);\n          system.state('active');\n        }\n      }.bind(this));\n\n      master = $db._System.find({\n        'master': true\n      });\n\n      master.forEach(function (dep) {\n        var system = this.require(dep._id);\n        channel = this.require('channel');\n\n        if (system && system.state && system.state() === 'resolved') {\n          system.state('starting');\n          system.start();\n          channel.$systemStarted(dep._id);\n          system.state('active');\n        }\n      }.bind(this));\n    }\n  }\n}",useCoreAPI:!0,core:!0},"1ba721201114b6b":{_id:"1ba721201114b6b",component:"_Component",state:"destroy",action:"function destroy() {\n  $component.destroy(this.id());\n}",core:!0,useCoreAPI:!0},"15486186f41a48c":{_id:"15486186f41a48c",component:"_Component",state:"off",action:'function off(state, behaviorId) {\n  var args = [],\n    i = 0,\n    numInjectedParams = 9,\n    length = arguments.length;\n\n  if ($helper.isOnNode()) {\n    numInjectedParams = numInjectedParams +1;\n  }\n\n  for (i = 0; i < length - numInjectedParams; i++) {\n    args.push(arguments[i]);\n  }\n\n  if ($workflow.checkInput({\n    "component": this,\n    "methodName": "off",\n    "args": args\n  })) {\n\n    if (state || behaviorId) {\n      if ($metamodel.isValidState(state, this.constructor.name)) {\n        $behavior.remove({\n          "behaviorId": behaviorId,\n          "componentId": this.id(),\n          "state": state\n        });\n      } else {\n        this.require(\'logger\').warn("invoke \\\'off\\\' method of component \'" + this.id() + "\' with an invalid state \'" + state + "\'");\n      }\n    } else {\n      $behavior.remove({\n        "componentId": this.id()\n      });\n    }\n  }\n}',core:!0,useCoreAPI:!0},"1da0a17878104c3":{_id:"1da0a17878104c3",component:"_Component",state:"require",action:"function require(id) {\n  return $component.get(id);\n}",core:!0,useCoreAPI:!0},"1a5111d17a1800c":{_id:"1a5111d17a1800c",component:"_Database",state:"collections",action:"function collections() {\n  var result = {},\n    collectionName = '';\n\n  for (collectionName in $db.store) {\n    if ($db.store.hasOwnProperty(collectionName)) {\n      result[collectionName] = $db[collectionName];\n    }\n  }\n  return result;\n}",core:!0,useCoreAPI:!0},"1d993108fa18ef2":{_id:"1d993108fa18ef2",component:"_Logger",state:"debug",action:"function debug(message) {\n  if (this.level() === 'debug') {\n    console.log('runtime: ' + message);\n  }\n}",core:!0},"1a37a188e11fe73":{_id:"1a37a188e11fe73",component:"_Logger",state:"error",action:"function error(message) {\n  if (this.level() === 'info' || this.level() === 'warn' || this.level() === 'debug' || this.level() === 'error') {\n    console.error('runtime: ' + message);\n  }\n}",core:!0},"1edd21e12a16534":{_id:"1edd21e12a16534",component:"_Logger",state:"info",action:"function info(message) {\n  if (this.level() === 'info' || this.level() === 'debug') {\n    console.info('runtime: ' + message);\n  }\n}",core:!0},"141f2143d3122a4":{_id:"141f2143d3122a4",component:"_Logger",state:"level",action:"function level(val) {\n  $log.level(val);\n}",core:!0,useCoreAPI:!0},"192401bab21304e":{_id:"192401bab21304e",component:"_Logger",state:"warn",action:"function warn(message) {\n  if (this.level() === 'info' || this.level() === 'warn' || this.level() === 'debug') {\n    console.warn('runtime: ' + message);\n  }\n}",core:!0},"11fc715e2f1a31e":{_id:"11fc715e2f1a31e",component:"_Metamodel",state:"create",action:"function create() {\n  $metamodel.create();\n}",core:!0,useCoreAPI:!0},"1232f1f107142cf":{_id:"1232f1f107142cf",component:"_Metamodel",state:"model",action:"function model(name, model) {\n  return $metamodel.model(name, model);\n}",core:!0,useCoreAPI:!0},"1365412f69153d2":{_id:"1365412f69153d2",component:"_Metamodel",state:"schema",action:"function schema(name, schema) {\n  return $metamodel.schema(name, schema);\n}",core:!0,useCoreAPI:!0},"194db147fe161a2":{_id:"194db147fe161a2",component:"_Metamodel",state:"type",action:"function type(name, type) {\n  return $metamodel.type(name, type);\n}",core:!0,useCoreAPI:!0},"1ef951f1411b895":{_id:"1ef951f1411b895",component:"_OSGi",state:"install",action:"function install(url, async) {\n  var importedSystem = null,\n    system = {},\n    systemId = '',\n    callbackLoad = null,\n    xhr = null,\n    result = '',\n    channel = $component.get('channel');\n\n  if (typeof url === 'object') {\n    importedSystem = url;\n  } else {\n    if (url.indexOf('{') === 0) {\n      importedSystem = JSON.parse(url);\n    }\n  }\n\n  if (importedSystem) {\n    systemId = $db.importSystem(importedSystem);\n    if (systemId) {\n      system = this.require(systemId);\n\n      if (typeof url === 'string') {\n        system.location(url);\n      }\n      system.state('installed');\n      channel.$systemInstalled(systemId);\n      system.state('resolved');\n      channel.$systemResolved(systemId);\n\n      result = systemId;\n    }\n  } else {\n    if (typeof global !== 'undefined' && typeof window === 'undefined') {\n      if (url.indexOf('.json') !== -1) {\n        if (typeof global.process.env.PWD === 'undefined') {\n          system = require(global.process.cwd() + '/' + url);\n        } else {\n          system = require(global.process.env.PWD + '/' + url);\n        }\n      } else {\n        system = require(url);\n      }\n      systemId = $db.importSystem(system);\n      system = this.require(systemId);\n\n      if (typeof url === 'string') {\n        system.location(url);\n      }\n      system.state('installed');\n      channel.$systemInstalled(systemId);\n      system.state('resolved');\n      channel.$systemResolved(systemId);\n\n      result = systemId;\n    } else {\n      xhr = new XMLHttpRequest();\n      callbackLoad = function callbackLoad(system, url) {\n        var sysId = $db.importSystem(system),\n          sys = $component.get(sysId),\n          channel = $component.get('channel');\n\n        if (typeof url === 'string') {\n          sys.location(url);\n        }\n        sys.state('installed');\n        channel.$systemInstalled(sysId);\n        sys.state('resolved');\n        channel.$systemResolved(sysId);\n\n        result = sysId;\n      };\n\n      if (async) {\n        xhr.open('GET', url, true);\n        xhr.onreadystatechange = function () {\n          if (xhr.readyState === 4) {\n            if (xhr.status === 200 || xhr.status === 0) {\n              if (xhr.response !== '') {\n                callbackLoad(JSON.parse(xhr.response), url);\n              }\n            }\n          }\n        };\n        xhr.send(null);\n      } else {\n        xhr.open('GET', url, false);\n        xhr.send(null);\n        if (xhr.status === 200 || xhr.status === 0) {\n          callbackLoad(JSON.parse(xhr.response), url);\n        }\n      }\n    }\n  }\n  return result;\n}",useCoreAPI:!0,core:!0},"14c1517b711cb78":{_id:"14c1517b711cb78",component:"_OSGi",state:"uninstall",action:"function uninstall(id) {\n  var search = {},\n    system = null,\n    behaviorId = '',\n    collection = '',\n    componentId = '',\n    length = 0,\n    i = 0,\n    coreComponents = ['admin', 'channel', 'db', 'logger', 'metamodel', 'runtime'];\n\n  search = $db._System.find({\n    '_id': id\n  });\n\n  if (search.length) {\n    system = search[0];\n    // remove behaviors\n    if (system.behaviors) {\n      for (behaviorId in system.behaviors) {\n        $db._Behavior.remove({\n          '_id': system.behaviors[behaviorId]._id\n        });\n      }\n    }\n    // remove components\n    if (system.components) {\n      for (collection in system.components) {\n        for (componentId in system.components[collection]) {\n          if (coreComponents.indexOf(componentId) === -1) {\n            $db[collection].remove({\n              '_id': componentId\n            });\n          }\n        }\n      }\n    }\n  }\n  if (this.require(id) && this.require(id).state) {\n    this.require(id).state('uninstalled');\n    this.require('channel').$systemUninstalled(id);\n  }\n}",useCoreAPI:!0,core:!0},"105f219c6813643":{_id:"105f219c6813643",component:"_OSGi",state:"start",action:"function start(id) {\n  var system = this.require(id),\n    channel = this.require('channel');\n\n  if (system && system.state() === 'resolved' || system.state() === 'installed') {\n    system.state('starting');\n    if (system.start) {\n      system.start();\n    }\n    channel.$systemStarted(id);\n    system.state('active');\n  }\n}",useCoreAPI:!1,core:!0},"1a81a1f00d17269":{_id:"1a81a1f00d17269",component:"_OSGi",state:"stop",action:"function stop(id) {\n  var system = this.require(id),\n    channel = this.require('channel');\n\n  if (system && system.state() === 'active') {\n    system.state('stopping');\n    if (system.stop) {\n      system.stop();\n    }\n    channel.$systemStopped(id);\n    system.state('resolved');\n    channel.$systemResolved(id);\n  }\n}",useCoreAPI:!1,core:!0},"116851b602128d1":{_id:"116851b602128d1",component:"_OSGi",state:"status",action:"function status() {\n  var result = {},\n    system = null,\n    length = 0,\n    i = 0;\n\n  systems = $db._System.find({});\n\n  length = systems.length;\n  for (i = 0; i < length; i++) {\n    system = systems[i];\n    result[system.name] = {\n      'id': system._id,\n      'state': system.state,\n      'name': system.name,\n      'version': system.version,\n      'location': system.location,\n      'master': system.master\n    };\n  }\n\n  return result;\n}",useCoreAPI:!0,core:!0},"19cf317d7217331":{_id:"19cf317d7217331",component:"_OSGi",state:"bundle",action:"function bundle() { \n\tvar result = $db.exportSystem();\n\treturn result;\n}",useCoreAPI:!0,core:!0},"13010167f313f87":{_id:"13010167f313f87",component:"_Runtime",state:"system",action:"function system(params) {\n  var RuntimeSystem = null,\n    system = {},\n    systemId = '',\n    result = [],\n    conf = {};\n\n  if (params) {\n    if (typeof params === 'string') {\n      conf.master = true;\n      conf.name = params;\n    } else {\n      conf = params;\n      conf.master = true;\n    }\n    RuntimeSystem = this.require('_System');\n    system = new RuntimeSystem(conf);\n    system.state('active');\n  } else {\n    result = $db._System.find({\n      'master': true\n    });\n    if (result.length) {\n      systemId = result[0]._id;\n      system = $component.get(systemId);\n    }\n  }\n  return system;\n}",core:!0,useCoreAPI:!0},"1cfa4145f614da8":{_id:"1cfa4145f614da8",component:"_Runtime",state:"message",action:"function message(msg) { \n  $db._Message.insert(msg);\n}",useCoreAPI:!0,core:!0},"1cb9d103d41dd97":{_id:"1cb9d103d41dd97",component:"e89c617b6b15d24",state:"start",action:"function start() {\n  if (typeof document !== 'undefined') {\n    document.addEventListener('DOMContentLoaded', function DOMContentLoaded(e) {\n      var systems = [],\n        system = null,\n        scripts = [],\n        script = null,\n        logLevel = 'warn',\n        i = 0,\n        length = 0;\n    \n      systems = document.querySelectorAll('link[rel=system]');\n      length = systems.length;\n  \n      // logger\n      scripts = document.querySelectorAll('script[log]');\n      if (scripts.length) {\n        logLevel = scripts[0].getAttribute('log');\n        this.require('logger').level(logLevel);\n      }\n  \n      // systems\n      for (i = 0; i < length; i++) {\n        system = systems[i];\n  \n        if (system.getAttribute('async') === 'false') {\n          this.require('runtime').install(system.href, false);\n        } else {\n          this.require('runtime').install(system.href, true);\n        }\n      }\n  \n      // ready event\n      if (length === 0) {\n        this.require('runtime').ready();\n      }\n  }.bind(this));\n  }\n}",useCoreAPI:!0,core:!0},"e2848b60-99a1-472f-b0e1-5923077f6c61":{_id:"e2848b60-99a1-472f-b0e1-5923077f6c61",component:"_History",state:"back",action:"function back() { \n  return $history.back();\n}",useCoreAPI:!0,core:!0},"cebc40ad-c704-405c-b499-e60390b1bb82":{_id:"cebc40ad-c704-405c-b499-e60390b1bb82",component:"_History",state:"forward",action:"function forward() { \n  return $history.forward();\n}",useCoreAPI:!0,core:!0},"c35af0df-2fc6-4af5-a476-4f2ee089c30e":{_id:"c35af0df-2fc6-4af5-a476-4f2ee089c30e",component:"_History",state:"dump",action:"function dump() { \n  return $history.dump();\n}",useCoreAPI:!0,core:!0},"f06254ad-187e-400c-a582-b5ab81f24747":{_id:"f06254ad-187e-400c-a582-b5ab81f24747",component:"_History",state:"get",action:"function get(index) { \n  return $history.get(index);\n}",useCoreAPI:!0,core:!0},"aa731445-8d7c-4dd7-a78f-5dd70f750f87":{_id:"aa731445-8d7c-4dd7-a78f-5dd70f750f87",component:"_History",state:"from",action:"function from(index) { \n  return $history.from(index);\n}",useCoreAPI:!0,core:!0},"f565e46e-daee-492d-99ca-d9ed123132ba":{_id:"f565e46e-daee-492d-99ca-d9ed123132ba",component:"_History",state:"load",action:"function load(dump) { \n  return $history.load(dump);\n}",useCoreAPI:!0,core:!0},"d3827b91-f6db-46d9-833e-351564cb6e91":{_id:"d3827b91-f6db-46d9-833e-351564cb6e91",component:"_History",state:"start",action:"function start() { \n  return $history.start();\n}",useCoreAPI:!0,core:!0},"aa3b13ab-8b69-4962-bc44-e975cd42a206":{_id:"aa3b13ab-8b69-4962-bc44-e975cd42a206",component:"_History",state:"stop",action:"function stop() { \n  return $history.stop();\n}",useCoreAPI:!0,core:!0},"b112782c-3633-443e-8d7a-8d379b44e32d":{_id:"b112782c-3633-443e-8d7a-8d379b44e32d",component:"_History",state:"clear",action:"function clear() { \n  return $history.clear();\n}",useCoreAPI:!0,core:!0}},types:{css:{_id:"h1d88311ac019211",name:"css",type:"string",core:!0},date:{_id:"c17cad1bc3d17752",name:"date",type:"object",core:!0},json:{_id:"e1d25a12e67127ed",name:"json",type:"object",core:!0},dbInsertEvent:{_id:"148ef1e19810e6d",core:!0,name:"dbInsertEvent",type:"object",schema:{collection:{type:"string",mandatory:!0,default:""},document:{type:"object",mandatory:!0,default:{}}}},dbRemoveEvent:{_id:"1952e1ac4213f4a",name:"dbRemoveEvent",type:"object",core:!0,schema:{collection:{type:"string",mandatory:!0,default:""},id:{type:"string",mandatory:!0,default:""}}},dbUpdateEvent:{_id:"1f5c41309711752",core:!0,name:"dbUpdateEvent",type:"object",schema:{collection:{type:"string",mandatory:!0,default:""},id:{type:"string",mandatory:!0,default:""},field:{type:"string",mandatory:!0,default:""},value:{type:"any",mandatory:!0,default:null}}},collection:{_id:"d1c0d0130c616199",name:"collection",type:"object",schema:{type:{type:["string"],mandatory:!0},readOnly:{type:"boolean",mandatory:!0},mandatory:{type:"boolean",mandatory:!0},default:{type:"array",mandatory:!0},description:{type:"string",mandatory:!1},label:{type:"string",mandatory:!1},kind:{type:"string",mandatory:!1}},core:!0},event:{_id:"g1668d1de2d1ff6f",name:"event",type:"object",schema:{params:{type:["parameter"],mandatory:!1},description:{type:"string",mandatory:!1}},core:!0},html:{_id:"y161c21320b11acb",name:"html",type:"string",core:!0},javascript:{_id:"s13d4c1fdf916504",name:"javascript",type:"string",core:!0},link:{_id:"p124601801d1dbfa",name:"link",type:"object",schema:{type:{type:"string",mandatory:!0},readOnly:{type:"boolean",mandatory:!0},mandatory:{type:"boolean",mandatory:!0},default:{type:"{type}",mandatory:!0},description:{type:"string",mandatory:!1},label:{type:"string",mandatory:!1},kind:{type:"string",mandatory:!1}},core:!0},log:{_id:"d1fd161a4a4149fc",name:"log",type:"string",value:["debug","info","warn","error","off"],core:!0},message:{_id:"l13b061ac571272d",name:"message",type:"object",schema:{event:{type:"string",mandatory:!0},from:{type:"string",mandatory:!1},data:{type:"array",mandatory:!0}},core:!0},method:{_id:"x1227218eed1f3e9",name:"method",type:"object",schema:{result:{type:"any",mandatory:!1},params:{type:["parameter"],mandatory:!1},description:{type:"string",mandatory:!1}},core:!0},osgiStates:{_id:"q1f0ca120fc13fb3",name:"osgiStates",type:"string",value:["none","installed","resolved","starting","active","stopping","uninstalled"],core:!0},parameter:{_id:"e1b18e16c6c195ad",name:"parameter",type:"object",schema:{description:{type:"string",mandatory:!1},name:{type:"string",mandatory:!0},type:{type:"any",mandatory:!0},mandatory:{type:"boolean",mandatory:!1},default:{type:"{type}",mandatory:!1}},core:!0},property:{_id:"a16a3a1ae051a55d",name:"property",type:"object",schema:{type:{type:"string",mandatory:!0},readOnly:{type:"boolean",mandatory:!0},mandatory:{type:"boolean",mandatory:!0},default:{type:"{type}",mandatory:!0},description:{type:"string",mandatory:!1},label:{type:"string",mandatory:!1}},core:!0},text:{_id:"c136fc129a912f54",name:"text",type:"string",core:!0},errorInfo:{_id:"e198761fc0b1ae8a",name:"errorInfo",type:"object",schema:{message:{type:"string",mandatory:!0},stack:{type:"object",mandatory:!0}},core:!0}},components:{_Channel:{channel:{_id:"channel"}},_Database:{db:{_id:"db"}},_Logger:{logger:{_id:"logger",level:"warn"}},_Metamodel:{metamodel:{_id:"metamodel"}},_Runtime:{runtime:{_id:"runtime",version:"5.3.0"}},_History:{history:{_id:"history"}}},_id:"e89c617b6b15d24"}},{}],2:[function(e,t,n){"use strict";var d=e("./db.js"),l=e("./helper.js"),r=e("./mson.js"),c={};function u(e,t,n){var a=-1,r=[],o="",i="",s=!0,d=!1,c=e;return-1!==c.indexOf(".")&&(c=e.split(".")[e.split(".").length-1]),(s=0===t.trim().indexOf("function")?!1:s)?(a=t.indexOf("=>"),(-1!==(i=(i=t.substring(0,a)).replace("=>","")).indexOf("(")?i.split("(")[1].replace(")",""):i).trim().split(",").forEach(function(e){r.push(e.trim())}),-1===(o=0===(o=t.substring(a+2,t.length).trim()).indexOf("{")?o.substring(1,o.lastIndexOf("}")).trim():o).indexOf("\n")&&(d=!0),s&&d&&-1===o.indexOf("return ")&&(o="return "+o)):(a=t.indexOf("{"),(i=t.substring(0,a)).split("(")[1].replace(")","").trim().split(",").forEach(function(e){r.push(e.trim())}),o=(o=t.substring(a+1)).substring(0,o.lastIndexOf("}")).trim()),o=o.replace(/_this/g,"this"),""===r[0]&&(r=[]),n&&(r.push("$component"),r.push("$db"),r.push("$metamodel"),r.push("$workflow"),r.push("$behavior"),r.push("$state"),r.push("$log"),r.push("$helper"),r.push("$history")),l.isOnNode()&&r.push("require"),(""!==r[0]?new Function("__action","return function "+c+" ("+r.join(", ")+") { return new Function('"+r.join("', '")+"', __action).apply(this, arguments) };"):new Function("__action","return function "+c+" () { return new Function(__action).apply(this, arguments) };"))(o)}n.add=function(e,t,n,a,r,o){var i=l.generateId(),s=n.toString();return void 0===r&&(r=!1),n=u(t,s,a=void 0===a?!1:a),c[i]=n,d._Behavior.insert({_id:i,component:e,state:t,action:s,useCoreAPI:a,core:r,context:o}),i},n.remove=function(e){(e=e||{}).behaviorId=e.behaviorId||"",e.componentId=e.componentId||"",e.state=e.state||"",e.componentId&&(e.behaviorId?(d._Behavior.remove({_id:e.behaviorId,component:e.componentId,state:e.state}),delete c[e.behaviorId]):(e.state?d._Behavior.remove({component:e.componentId,state:e.state}):d._Behavior.remove({component:e.componentId})).forEach(function(e){delete c[e]}))},n.removeFromMemory=function(e){delete c[e]},n.getActions=function(e,t){var n=[],a=null;return d._Behavior.find({component:e,state:t}).forEach(function(e){void 0===(a=c[e[r.ID]])&&(a=u(e.state,e.action,e.useCoreAPI),c[e[r.ID]]=a),n.push({useCoreAPI:e.useCoreAPI,context:e.context,action:a})}),n},n.clear=function(){c={}},n.get=function(e){return c[e]}},{"./db.js":4,"./helper.js":5,"./mson.js":9}],3:[function(e,t,g){"use strict";var v=e("./workflow.js"),b=e("./db.js"),_=e("./metamodel.js"),d=e("./behavior.js"),O=e("./helper.js"),S=e("./log.js"),I=e("./history.js"),c=e("./state.js"),l=e("./mson.js"),N={};function w(r){var d,c,l,u,a=[],m=[],y="",f=!1;function p(){var t=0,e=0,n=a.length;for(m.forEach(function(e){a[t]=u?O.getRuntime().require(e):e,t+=1}),e=t;e<n;e++)delete a[e];a.length=m.length}function h(e,t,n,a){var r,o,i=0,s=null;if(I.isEnabled()&&(s=JSON.stringify(m)),f)S.readOnlyProperty(c,y,l);else if(u)if(e&&_.inheritFrom(e.constructor.name,d)){switch(!0){case"push"===t:m.push(e.id());break;case"unshift"===t:m.unshift(e.id());break;case"splice"===t:for(r=(o=m.splice(n,a,e)).length,i=0;i<r;i++)v.process({component:c,state:l,data:[N[o[i]],"remove"]})}I.isEnabled()&&0!==y.indexOf("_")&&I.pushState({action:"update",collection:y,id:c,field:l,value:JSON.stringify(m),oldValue:s}),O.isRuntime()&&O.getRuntime().require("db").update({collection:y,id:c,field:l,value:m}),v.process({component:c,state:l,data:[e,"add"]})}else S.invalidPropertyName(c,y,l,e,d);else if(e&&_.isValidType(e,d)){switch(!0){case"push"===t:m.push(e);break;case"unshift"===t:m.unshift(e);break;case"splice"===t:m.splice(n,a,e)}I.isEnabled()&&0!==y.indexOf("_")&&I.pushState({action:"update",collection:y,id:c,field:l,value:JSON.stringify(m),oldValue:s}),O.isRuntime()&&O.getRuntime().require("db").update({collection:y,id:c,field:l,value:m}),v.process({component:c,state:l,data:[e,"add"]})}else S.invalidPropertyName(c,y,l,e,d);return m.length}function n(e){var t,n=null,a=null;if(I.isEnabled()&&(a=JSON.stringify(m)),f)S.readOnlyProperty(c,y,l);else if(0!==m.length){switch(!0){case"pop"===e:n=m.pop();break;case"shift"===e:n=m.shift()}I.isEnabled()&&0!==y.indexOf("_")&&I.pushState({action:"update",collection:y,id:c,field:l,value:JSON.stringify(m),oldValue:a}),O.isRuntime()&&O.getRuntime().require("db").update({collection:y,id:c,field:l,value:m}),t=u?N[n]:n,v.process({component:c,state:l,data:[t,"remove"]})}return t}return d=(r=r||{}).type||"",c=r.id||"",l=r.propertyName||"",m=r.arr||[],y=r.classId||"",void 0!==r.readOnly&&(f=r.readOnly),u=_.isClassName(d),m.forEach(function(e){a.push(u?O.getRuntime().require(e):e)}),a.push=function(e){var t=h(e,"push");return a[a.length]=e,t},a.pop=function(){var e=n("pop"),t=a.length;return 0!==t&&(delete a[t],a.length=t-1),e},a.shift=function(){var e=n("shift");return p(),e},a.unshift=function(e){e=h(e,"unshift");return p(),e},a.concat=function(e){var t,n,a=0;if(Array.isArray(e))for(t=e.length,a=0;a<t;a++)h(e[a],"push");return r.arr=m,n=new w(r),p(),n},a.sort=function(e){var t=null;return I.isEnabled()&&(t=JSON.stringify(m)),m.sort(e),I.isEnabled()&&0!==y.indexOf("_")&&I.pushState({action:"update",collection:y,id:c,field:l,value:JSON.stringify(m),oldValue:t}),O.isRuntime()&&O.getRuntime().require("db").update({collection:y,id:c,field:l,value:m}),p(),a},a.reverse=function(){var e=null;return I.isEnabled()&&(e=JSON.stringify(m)),m.reverse(),I.isEnabled()&&0!==y.indexOf("_")&&I.pushState({action:"update",collection:y,id:c,field:l,value:JSON.stringify(m),oldValue:e}),O.isRuntime()&&O.getRuntime().require("db").update({collection:y,id:c,field:l,value:m}),p(),a},a.splice=function(e,t,n){var a,r=null,o=[],i=0,s=null;if(I.isEnabled()&&(r=JSON.stringify(m)),void 0!==n)h(n,"splice",e,t);else for(o=m.splice(e,t),I.isEnabled()&&0!==y.indexOf("_")&&I.pushState({action:"update",collection:y,id:c,field:l,value:JSON.stringify(m),oldValue:r}),O.isRuntime()&&O.getRuntime().require("db").update({collection:y,id:c,field:l,value:m}),a=o.length,i=0;i<a;i++)s=u?N[o[i]]:o[i],v.process({component:c,state:l,data:[s,"remove"]});return p(),o},a.slice=function(e,t){e=m.slice(e,t);return p(),e},a}function u(e,t){var n,a,r=[],o=0;if(a=_.getModel(e)[t].params)for(n=a.length,o=0;o<n;o++)r.push(a[o].name);return r}function k(e,t,n){for(var a,r,o=null,e=b.store[e][t],i=n.split("."),s=i.length,d=0,o=e,d=0;d<s;d++)o=-1!==i[d].indexOf("[")?(a=i[d].split("[")[0],r=i[d].split("[")[1].replace("]",""),o[a][r]):o&&o[i[d]];return o}function x(e,t,n,a){for(var r,o,i=null,e=b.store[e][t],s=n.split("."),d=s.length,c=0,i=e,c=0;c<d-1;c++)i=-1!==s[c].indexOf("[")?(r=s[c].split("[")[0],o=s[c].split("[")[1].replace("]",""),i[r][o]):i[s[c]];i[s[c]]=a}function m(p,n,h){(function(e){for(var t,n=0,a=[],r=_.getModel(e),o=_.getSchema(r[l.NAME]),i=(t=Object.keys(o)).length,n=0;n<i;n++)o[t[n]]!==l.LINK_TYPE&&o[t[n]]!==l.PROPERTY_TYPE&&o[t[n]]!==l.COLLECTION_TYPE||a.push({name:t[n],type:r[t[n]].type,readOnly:r[t[n]].readOnly});return a})(p).forEach(function(e){var t={},m="",y="",f="";m=e.name,y=e.type,f=e.readOnly,Array.isArray(y)||"array"===y?(t=function(e,t){var n,a,r,o,i,s,d=[],c=null,l=null,u=null;if(void 0===t){if(void 0===e)return new w({id:this.id(),propertyName:m,readOnly:f,classId:h,type:"array"===y?"any":y[0],arr:b.store[h][this.id()][m]});if(Array.isArray(e))o=e,i="array"===y?"any":y[0],s=!0,"any"!==i&&o.forEach(function(e){_.isClassName(i)?_.isValidType(e,i)||_.inheritFrom(e.constructor.name,i)||(s=s&&!1):_.isValidType(e,i)||(s=s&&!1)}),s?(d=b[h].find({_id:this.id()})).length&&(c=d[0],a="array"===y?"any":y[0],r=[],e.forEach(function(e){if(_.isClassName(a))switch(!0){case"string"==typeof e:r.push(e);break;case void 0!==e.id:r.push(e.id());break;default:r.push(null)}else r.push(e)}),l=r,v.process({component:this.id(),state:m,data:[e,"reset"]}),I.isEnabled()&&(u=JSON.stringify(c[m])),c[m]=l,I.isEnabled()&&0!==h.indexOf("_")&&I.pushState({action:"update",collection:h,id:this.id(),field:m,value:JSON.stringify(c[m]),oldValue:u}),O.isRuntime())&&O.getRuntime().require("db").update({collection:h,id:this.id(),field:m,value:c[m]}):S.invalidCollectionItem(this.id(),this.constructor.name,m,e,"array"===y?"any":y[0]);else if("number"==typeof e){if(n=b.store[h][this.id()][m][e]){switch(!0){case _.isClassName("array"===y?"array":y[0]):l=O.getRuntime().require(n);break;case"array"===y?"array":"date"===y[0]:l=new Date(n);break;case _.isStructure(m,p):l=E("",m+"["+e+"]",p,this.id());break;default:l=n}return l}}else S.invalidPropertyName(this.id(),this.constructor.name,m,e,"number")}else if(f)S.readOnlyProperty(this.id(),this.constructor.name,m);else if(_.isValidType(t,"array"===y?"any":y[0])||_.inheritFrom(t.constructor.name,"array"===y?"array":y[0])&&_.isClassName("array"===y?"array":y[0])){if((d=b[h].find({_id:this.id()})).length){switch(!0){case _.isClassName("array"===y?"array":y[0]):switch(!0){case"string"==typeof t:l=t;break;case void 0!==t.id:l=t.id();break;default:l=""}break;case!!Array.isArray(y)&&y[0]:l="string"==typeof t?t:t.toISOString();break;default:l=""}(c=d[0])[m][e]=l,I.isEnabled()&&(u=JSON.stringify(c[m])),I.isEnabled()&&0!==h.indexOf("_")&&I.pushState({action:"update",collection:h,id:this.id(),field:m,value:JSON.stringify(c[m]),oldValue:u}),O.isRuntime()&&O.getRuntime().require("db").update({collection:h,id:this.id(),field:m,value:c[m]}),v.process({component:this.id(),state:m,data:[t,"add"]})}}else S.invalidPropertyName(this.id(),this.constructor.name,m,t,y[0])},n.prototype[m]=new Function("__proxy","return function "+m+" (position, value) { return __proxy.apply(this, arguments) };")(t)):(t=function(e){var t,n=null,a=null,r=null,o=null;if(void 0===e){if(n=b.store[h][this.id()]){switch(!0){case _.isClassName(y):a=g.get(n[m]);break;case"date"===y:a=new Date(n[m]);break;case"json"===y:a=n[m],a=JSON.parse(JSON.stringify(a));break;case"array"===y:a=new w({id:this.id(),propertyName:m,readOnly:f,classId:h,type:"any",arr:b.store[h][this.id()][m]});break;case _.isStructure(m,h):a=E("",m,p,this.id());break;default:a=n[m]}return a}S.destroyedComponentCall(m,this.id())}else if(f)S.readOnlyProperty(this.id(),this.constructor.name,m);else if(_.isValidType(e,y)){if((t=b[h].find({_id:this.id()})).length){switch(n=t[0],I.isEnabled()&&(r=JSON.stringify(n[m])),!0){case _.isClassName(y):o=null===e?e:e.id();break;case"date"===y:"string"==typeof e?o=e:(o=e.toISOString(),n[m]=e.toISOString());break;default:o=e}n[m]=o,I.isEnabled()&&0!==h.indexOf("_")&&I.pushState({action:"update",collection:h,id:this.id(),field:m,value:JSON.stringify(o),oldValue:r}),O.isRuntime()&&O.getRuntime().require("db")&&O.getRuntime().require("db").update({collection:h,id:this.id(),field:m,value:o}),"_Behavior"===h&&d.removeFromMemory(this.id()),v.process({component:this.id(),state:m,data:[e]})}}else S.invalidPropertyName(this.id(),this.constructor.name,m,e,y)},n.prototype[m]=new Function("__proxy","return function "+m+" (value) { return __proxy.apply(this, arguments) };")(t))})}function E(y,f,p,h){a=y?y+"."+f:f,e=p,t=null,n=[],e=_.getModelPathType(p,a),(t=_.getType(e))&&t.schema&&Object.keys(t.schema).forEach(function(e){t.schema[e].name=e,n.push(t.schema[e])});var e,t,n,a=n,r=void 0;return k(p,h,y?y+"."+f:f)&&(r={},a.forEach(function(s){var e={},l="",u="",m="",l=s.name,u=s.type,m=s.readOnly;Array.isArray(u)||"array"===u?(e=function(e,t){var n,a,r,o=null,i="",s="",d=null;if(s=(i=y?y+"."+f:f)+"."+l,void 0===t){if(void 0===e)return new w({id:h,propertyName:s,readOnly:m,classId:p,type:Array.isArray(u)?u[0]:"any",arr:k(p,h,s)});if(Array.isArray(e))n=e,a=Array.isArray(u)?u[0]:"any",r=!0,n.forEach(function(e){_.isValidType(e,a)||(r=r&&!1)}),r?b[p].find({_id:h}).length&&(I.isEnabled()&&(d=k(p,h,s)),x(p,h,s,e),-1!==s.indexOf("[")&&v.process({component:h,state:s.replace(/\[(\d)*\]/g,""),data:[e,"reset"]}),v.process({component:h,state:s,data:[e,"reset"]}),I.isEnabled()&&0!==p.indexOf("_")&&I.pushState({action:"update",collection:p,id:h,field:s,value:JSON.stringify([]),oldValue:JSON.stringify(d)}),O.isRuntime())&&O.getRuntime().require("db").update({collection:p,id:h,field:s,value:e}):S.invalidPropertyName(h,this.constructor.name,l,e,u[0]);else if("number"==typeof e)if(b.store[p][h])switch(!0){case _.isClassName(Array.isArray(u)?u[0]:"any"):return o=g.get(k(p,h,s+"["+e+"]"));case!!Array.isArray(u)&&u[0]:return o=new Date(k(p,h,s+"["+e+"]"));case!!Array.isArray(u)&&u[0]:return o=k(p,h,s+"["+e+"]"),o=JSON.parse(JSON.stringify(o));case _.isStructure(s,p):return o=E(i,l+"["+e+"]",p,h);default:return o=k(p,h,s+"["+e+"]")}else S.destroyedComponentCall(s[e]+"["+e+"]",h);else S.invalidPropertyName(h,this.constructor.name,l,e,"number")}else if(m)S.readOnlyProperty(h,this.constructor.name,l);else if(_.isValidType(t,Array.isArray(u)?u[0]:"any")){if(b[p].find({_id:h}).length){var c=k(p,h,s);switch(void 0===c&&(c=[]),!0){case _.inheritFrom(t.constructor.name,Array.isArray(u)?u[0]:"any")&&_.isClassName(Array.isArray(u)?u[0]:"any"):c[e]=t.id();break;case!!Array.isArray(u)&&u[0]:c[e]=t.toISOString();break;default:c[e]=t}I.isEnabled()&&(d=k(p,h,s)),x(p,h,s,c),I.isEnabled()&&0!==p.indexOf("_")&&I.pushState({action:"update",collection:p,id:h,field:s,value:JSON.stringify(t),oldValue:JSON.stringify(d)}),O.isRuntime()&&O.getRuntime().require("db").update({collection:p,id:h,field:s,value:c}),-1!==s.indexOf("[")&&v.process({component:h,state:s.replace(/\[(\d)*\]/g,""),data:[t,"add"]}),v.process({component:h,state:s,data:[t,"add"]})}}else S.invalidPropertyName(h,this.constructor.name,l,t,Array.isArray(u)?u[0]:"any")},r[l]=new Function("__proxy","return function "+l+" (position, value) { return __proxy.apply(this, arguments) };")(e)):(e=function(e){var t,n=null,a="",r="",o=null,i=null,r=(a=y?y+"."+f:f)+"."+l;if(void 0===e){if(b.store[p][h]){switch(!0){case _.isClassName(u):n=g.get(k(p,h,r));break;case"date"===u:n=new Date(k(p,h,r));break;case"json"===u:n=k(p,h,r),n=JSON.parse(JSON.stringify(n));break;case _.isStructure(r,p):n=E(a,l,p,h);break;default:n=k(p,h,r)}return n=void 0===n&&void 0!==s.default?s.default:n}S.destroyedComponentCall(r,h)}else if(m)S.readOnlyProperty(h,p,r);else if(_.isValidType(e,u)){if((t=b[p].find({_id:h})).length){switch(t[0],I.isEnabled()&&(o=k(p,h,r)),!0){case _.isClassName(u):i=e.id();break;case"date"===u:i=e.toISOString();break;default:i=e}x(p,h,r,i),I.isEnabled()&&0!==p.indexOf("_")&&I.pushState({action:"update",collection:p,id:h,field:r,value:JSON.stringify(i),oldValue:JSON.stringify(o)}),O.isRuntime()&&O.getRuntime().require("db")&&O.getRuntime().require("db").update({collection:p,id:h,field:r,value:i}),"_Behavior"===p&&d.removeFromMemory(h),-1!==r.indexOf("[")&&v.process({component:h,state:r.replace(/\[(\d)*\]/g,""),data:[e]}),v.process({component:h,state:r,data:[e]})}}else S.invalidPropertyName(h,p,r,e,u)},r[l]=new Function("__proxy","return function "+l+" (value) { return __proxy.apply(this, arguments) };")(e))})),r}function y(e,o,i){(function(e){for(var t,n=0,a=[],e=_.getModel(e),r=_.getSchema(e[l.NAME]),o=(t=Object.keys(r)).length,n=0;n<o;n++)r[t[n]]===l.METHOD_TYPE&&a.push(t[n]);return a})(e).forEach(function(n){function e(){return v.process({component:this.id(),state:n,data:arguments})}function t(){var e=null,t=Array.prototype.slice.call(arguments);return t.shift(),arguments[0]?e=v.process({component:this.id(),state:n,data:t,context:arguments[0]}):S.unknownContext(i,n),e}var a=u(i,n),r=a.join(", ");r?(a.unshift("context"),a=a.join(", "),o.prototype[n]=new Function("__proxy","return function "+n+" ("+r+") { return __proxy.apply(this, arguments) };")(e),"name"!==n&&(o[n]=new Function("__proxy","return function "+n+" ("+a+") { return __proxy.apply(this, arguments) };")(t))):(o.prototype[n]=new Function("__proxy","return function "+n+" () { return __proxy.apply(this) };")(e),"name"!==n&&(o[n]=new Function("__proxy","return function "+n+" (context) { return __proxy.apply(this, arguments) };")(t)))})}function f(e,n,s){(function(e){for(var t,n=0,a=[],e=_.getModel(e),r=_.getSchema(e[l.NAME]),o=(t=Object.keys(r)).length,n=0;n<o;n++)r[t[n]]===l.EVENT_TYPE&&a.push(t[n]);return a})(e).forEach(function(i){function e(){var e,t,n="e89c617b6b15d24",a=[],r=0,o={};if("_Channel"===s){for((e=b._System.find({master:!0})).length&&(n=e[0][l.ID]),o.from=n,t=arguments.length,r=0;r<t;r++)a.push(arguments[r]);o.data=a,o.event=i,b._Message.insert(o),v.process({component:this.id(),state:"send",data:[{event:o.event,from:o.from,data:o.data}]})}else v.process({component:this.id(),state:i,data:arguments})}var t=u(s,i).join(", ");n.prototype[i]=(t?new Function("__proxy","return function "+i+" ("+t+") { return __proxy.apply(this, arguments) };"):new Function("__proxy","return function "+i+" () { return __proxy.apply(this) };"))(e)})}function n(e){var n,t,a,i,s,r={},o="",o=void 0===(e=e||{}).model?O.generateId():e.model;return n=o,r=new Function("__proxy","return function "+n+" (config) { __proxy.apply(this, arguments) };")(function(e){var t={};"Object"!==(e=e||{}).constructor.name&&(S.invalidConctructorParameters(e,n),e={}),_.isValidObject(e,_.getModel(n),!0,!0)||S.invalidParameters(n,e),_.prepareObject(e,_.getModel(n)),void 0===e[l.ID]&&(e[l.ID]=O.generateId()),t=function(){return e[l.ID]},(N[e[l.ID]]=this).id=new Function("__proxy","return function id () { return __proxy.apply(this) };")(t),b.store[n][e[l.ID]]=e,I.isEnabled()&&0!==n.indexOf("_")&&I.pushState({action:"insert",collection:n,id:e[l.ID],value:JSON.stringify(e)}),O.isRuntime()&&O.getRuntime().require("db")&&O.getRuntime().require("db").insert({collection:n,document:e}),Object.freeze(this),this.init&&this.init(e)}),N[o]=r,t=o,r.id=new Function("__proxy","return function id () { return __proxy.apply(this) };")(function(){return t}),m(e.model,r,o),y(e.model,r,o),f(e.model,r,o),_.inheritFrom(o,"_Component")&&(s=o,r.prototype.on=new Function("__proxy","return function on (state, action, useCoreAPI, isCore) { return __proxy.apply(this, arguments) };")(function(e,t,n,a){var r="",o=null;return n&&n.constructor&&"Boolean"!==n.constructor.name&&(o=n,a=!(n=!1)),v.checkInput({component:this,methodName:"on",args:arguments})&&(_.isValidState(e,s)?_.isEvent(e,s)||_.isProperty(e,s)||_.isLink(e,s)||_.isCollection(e,s)||!(1<=b._Behavior.find({component:this.id(),state:e}).length)?v.checkInputNumbers(s,e,t)?(r=d.add(this.id(),e,t,n,a,o),(t=c.get(this.id()))&&t.state===e&&v.process({id:r,data:t.value})):S.invalidParamNumberMethodOn(this.id(),this.constructor.name,e):S.behaviorNotUnique(s,e):S.invalidStateOn(s,e)),r}),i=o,r.on=new Function("__proxy","return function on (state, action, useCoreAPI, isCore) { return __proxy.apply(this, arguments) };")(function(e,t,n,a){var r="",o=null;return n&&n.constructor&&"Boolean"!==n.constructor.name&&(o=n,a=!(n=!1)),v.checkInput({component:this,methodName:"on",args:arguments})&&(_.isValidState(e,i)?_.isEvent(e,i)||_.isProperty(e,i)||_.isLink(e,i)||_.isCollection(e,i)||!(1<=b._Behavior.find({component:this.id(),state:e}).length)?v.checkInputNumbers(i,e,t)?(r=d.add(this.id(),e,t,n,a,o),(t=c.get(this.id()))&&t.state===e&&v.process({id:r,data:t.value})):S.invalidParamNumberMethodOn(this.id(),this.constructor.name,e):S.behaviorNotUnique(i,e):S.invalidStateOn(i,e)),r}),a=o,r.off=new Function("__proxy","return function off (state, behaviorId) { return __proxy.apply(this, arguments) };")(function(e,t){v.checkInput({component:this,methodName:"off",args:arguments})&&(_.isValidState(e,a)?d.remove({behaviorId:t,componentId:a,state:e}):S.invalidStateOff(a,e))}),r.require=new Function("__proxy","return function require (id) { return __proxy.apply(this, arguments) };")(function(e){return g.get(e)}),r.init=new Function("__proxy","return function init (conf) { return __proxy.apply(this, arguments) };")(function(){}),r.destroy=new Function("__proxy","return function destroy () { return __proxy.apply(this) };")(function(){var e,t=this.id(),n=[],a=0;for(b[t]&&(n=b[t].remove()),delete N[t],d.remove({componentId:t}),e=n.length,a=0;a<e;a++)d.remove({componentId:n[a]});v.process({component:t,state:"destroy"})})),Object.freeze(r),r}w.prototype=[],g.get=function(e){return N[e]},g.create=n,g.destroy=function(e){var t=N[e];t&&(delete N[e],t=t.constructor.name,b[t].remove({_id:e}),d.remove({componentId:e}),"_Behavior"===t)&&d.removeFromMemory(e)},g.removeFromMemory=function(e){delete N[e]},g.clear=function(){N={}}},{"./behavior.js":2,"./db.js":4,"./helper.js":5,"./history.js":6,"./log.js":7,"./metamodel.js":8,"./mson.js":9,"./state.js":11,"./workflow.js":12}],4:[function(e,t,f){"use strict";var l=e("./component.js"),u=e("./metamodel.js"),m=e("./helper.js"),y=e("./log.js"),p=e("./history.js"),n=e("./behavior.js"),a=e("./state.js"),h=e("./workflow.js"),g=e("./mson.js"),v=[],r=["_Runtime","_Schema","_GeneratedSchema","_Model","_GeneratedModel","_Behavior","_Type","_Metamodel","_Database","_System","_Message","_Channel","_Logger","_History"],o=["_Schema","_GeneratedSchema","_Logger","_Model","_GeneratedModel","_Type","_History"];function i(){var e=[];return e.sort=function(n){var a,t=[];return e.forEach(function(e){t.push(e)}),n instanceof Function?t.sort(n):(a=Object.keys(n)[0],t.sort(function(e,t){return e[a]<t[a]?1===n[a]?-1:1:e[a]>t[a]?1===n[a]?1:-1:0})),t},e}function s(e,t){var n,a=!0,r=!1,o="",i=0;e:for(o in e){if(void 0===t[o]){a=!1;break}switch(!0){case e[o]instanceof RegExp:if(Array.isArray(t[o])&&!Array.isArray(e[o])){for(n=t[o].length,i=0;i<n;i++)if(null!==t[o][i].toString().match(e[o])){r=!0;break e}a=r}else if(null===t[o].toString().match(e[o])){a=!1;break e}break;case e[o]instanceof Object&&!Array.isArray(e[o]):a=function(e,t,n){var a=!0,r="";t:for(r in t)switch(!0){case"$eq"===r:if(t[r]instanceof RegExp){if(null===n[e].toString().match(t[r])){a=!1;break t}}else if(n[e]!==t[r]){a=!1;break t}break;case"$gt"===r:if(n[e]<=t[r]){a=!1;break t}break;case"$gte"===r:if(n[e]<t[r]){a=!1;break t}break;case"$lt"===r:if(n[e]>=t[r]){a=!1;break t}break;case"$lte"===r:if(n[e]>t[r]){a=!1;break t}break;case"$ne"===r:if(n[e]!==t[r])break;a=!1;break t;case"$in"===r:if(Array.isArray(t[r])&&-1===t[r].indexOf(n[e])){a=!1;break t}break;case"$nin"===r:if(Array.isArray(t[r])&&-1!==t[r].indexOf(n[e])){a=!1;break t}}return a}(o,e[o],t);break;case Array.isArray(t[o])&&!Array.isArray(e[o]):if(-1!==t[o].indexOf(e[o]))break;a=!1;break e;default:if(t[o]===e[o])break;a=!1;break e}}return a}function d(){var e,t,n="",a="",r=null,o={};if((t=f._System.find({master:!0})).length){for(a in e=(t=t[0])[g.ID],o[g.ID]=e,o.name=t.name,o.description=t.description,o.version=t.version,o.master=!0,r=function(){var e,t,n,a,r,o,i={},s="",d="",c=null,l="",u="",m=0,y="";if(i.schemas={},f._Schema.count())for(l in f.store._Schema)f.store._Schema[l][g.CORE]||(a=JSON.parse(JSON.stringify(f.store._Schema[l])),i.schemas[l]=a);if(i.models={},f._Model.count())for(u in f.store._Model)f.store._Model[u][g.CORE]||(r=JSON.parse(JSON.stringify(f.store._Model[u])),i.models[u]=r);if(i.types={},f._Type.count())for(d in f.store._Type)f.store._Type[d].core||(t=JSON.parse(JSON.stringify(f.store._Type[d])),i.types[t.name]=t);for(s in i.behaviors={},f.store._Behavior)f.store._Behavior[s].core||(n=JSON.parse(JSON.stringify(f.store._Behavior[s])),i.behaviors[s]=n);for(i.components={},o=v.length,m=0;m<o;m++)if(e=v[m],f[e].count()){for(y in c=JSON.parse(JSON.stringify(f.store[e])))c[y][g.CORE]&&delete c[y];Object.keys(c).length&&(i.components[e]=c)}return i}())r.hasOwnProperty(a)&&(o[a]=r[a]);n=JSON.stringify(o)}else n="{}",y.masterSystemNotFound();return n}i.prototype=[],f.store={};function c(e){u.getSchema(e)||-1!==r.indexOf(e)?(f.store[e]={},this.name=e,-1===r.indexOf(e)&&v.push(e)):y.invalidCollectionName(e)}c.prototype.find=function(e){var t=new i,n={},a="",r={};if((e=e||null)&&Object.keys(e).length)if(Array.isArray(e))e.forEach(function(e){for(a in f.store[this.name])s(e,r=f.store[this.name][a])&&void 0===n[a]&&(t.push(r),n[a]=!0)}.bind(this));else for(a in f.store[this.name])s(e,r=f.store[this.name][a])&&t.push(r);else for(a in f.store[this.name])r=f.store[this.name][a],t.push(r);return t},c.prototype.insert=function(e){var t=[],r=null,o=[];return Array.isArray(e)?t=e:t.push(e),t.forEach(function(e){switch(!0){case null===e:y.invalidDocumentOnDbInsert(e,this.name);break;case"_Schema"===this.name:case"_Logger"===this.name:case"_Model"===this.name:case"_Type"===this.name:case"_GeneratedModel"===this.name:case"_GeneratedSchema"===this.name:case u.isValidObject(e,u.getModel(this.name)):if(void 0===e[g.ID]&&(e[g.ID]=m.generateId()),u.prepareObject(e,u.getModel(this.name)),f.store[this.name][e[g.ID]]=e,o.push(e[g.ID]),(r=l.get(this.name))?new r(e):(p.isEnabled()&&0!==this.name.indexOf("_")&&p.pushState({action:"insert",collection:this.name,id:e[g.ID],value:JSON.stringify(e)}),m.isRuntime()&&m.getRuntime().require("db")&&m.getRuntime().require("db").insert({collection:this.name,document:e})),"_Message"===this.name&&m.isRuntime())for(var t,n=(t=f._Channel.find({})).length,a=0;a<n;a++)m.getRuntime().require(t[a][g.ID]),h.process({component:t[a][g.ID],state:e.event,data:e.data});break;default:y.invalidDocumentOnDbInsert(e,this.name)}}.bind(this)),o},c.prototype.update=function(e,t,n){var a=this.find(e),r=[],o=0,i=a.length,s="",d=u.getModel(this.name),c="";if(void 0===(n=n||{}).upsert&&(n.upsert=n.upsert||!1),t)for(0===i&&n.upsert&&(e[g.ID]&&(t[g.ID]=e[g.ID]),1===(n=this.insert(t)).length)&&r.push(n[0]),o=0;o<i;o++)for(s in void 0!==t[g.ID]&&t[g.ID]!==a[o][g.ID]&&y.updateUuid(a[o][g.ID],t[g.ID],void 0!==l.get(t[g.ID])),t)void 0!==a[o][s.split(".")[0]]&&("_Schema"!==this.name&&"_GeneratedSchema"!==this.name&&"_Model"!==this.name&&"_GeneratedModel"!==this.name?(c="",0!==s.indexOf("_")?c=-1!==s.indexOf(".")?u.getModelPathType(this.name,s):d[s].type:g.SCHEMA_DEFINITION[s]&&(c=g.SCHEMA_DEFINITION[s].type),c?u.isValidType(t[s],c,!0)?(p.isEnabled()&&0!==this.name.indexOf("_")&&p.pushState({action:"update",collection:this.name,id:a[o][g.ID],field:s,value:JSON.stringify(t[s]),oldValue:JSON.stringify(a[o][s])}),a[o][s]=t[s],r.push(a[o][g.ID]),m.isRuntime()&&m.getRuntime().require("db")&&m.getRuntime().require("db").update({collection:this.name,id:a[o][g.ID],field:s,value:t[s]}),"array"===c?h.process({component:a[o][g.ID],state:s,data:[t[s],"reset"]}):h.process({component:a[o][g.ID],state:s,data:[t[s]]})):y.invalidPropertyTypeOnDbUpdate(this.name,a[o][g.ID],s,t[s],c):y.unknownPropertyOnDbUpdate(this.name,s,a[o][g.ID])):(p.isEnabled()&&0!==this.name.indexOf("_")&&p.pushState({action:"update",collection:this.name,id:a[o][g.ID],field:s,value:JSON.stringify(t[s]),oldValue:JSON.stringify(a[o][s])}),a[o][s]=t[s],r.push(a[o][g.ID]),m.isRuntime()&&m.getRuntime().require("db")&&m.getRuntime().require("db").update({collection:this.name,id:a[o][g.ID],field:s,value:t[s]})));return r},c.prototype.remove=function(e){var t=[],n="",a=null;if((e=e||null)&&Object.keys(e).length)if(Array.isArray(e))e.forEach(function(e){for(n in f.store[this.name])s(e,f.store[this.name][n])&&(p.isEnabled()&&0!==this.name.indexOf("_")&&p.pushState({action:"remove",collection:this.name,id:n,oldValue:JSON.stringify(f.store[this.name][n])}),delete f.store[this.name][n],t.push(n),(a=l.get(n))&&a.destroy(),m.isRuntime())&&m.getRuntime().require("db")&&m.getRuntime().require("db").remove({collection:this.name,id:n})}.bind(this));else for(n in f.store[this.name])s(e,f.store[this.name][n])&&(p.isEnabled()&&0!==this.name.indexOf("_")&&p.pushState({action:"remove",collection:this.name,id:n,oldValue:JSON.stringify(f.store[this.name][n])}),delete f.store[this.name][n],t.push(n),(a=l.get(n))&&a.destroy(),m.isRuntime())&&m.getRuntime().require("db")&&m.getRuntime().require("db").remove({collection:this.name,id:n});else for(n in f.store[this.name])p.isEnabled()&&0!==this.name.indexOf("_")&&p.pushState({action:"remove",collection:this.name,id:n,oldValue:JSON.stringify(f.store[this.name][n])}),delete f.store[this.name][n],-1===o.indexOf(this.name)&&(a=l.get(n))&&a.destroy(),m.isRuntime()&&m.getRuntime().require("db")&&m.getRuntime().require("db").remove({collection:this.name,id:n}),t.push(n);return t},c.prototype.count=function(){var e=0,t="";for(t in f.store[this.name])e++;return e},f.collection=function(e){f[e]=new c(e)},f.importSystem=function(e){var t=e,e="",n="",a="",r="",o="",i="",s="",d=[];if(t){for(r in t.types)u.type(t.types[r]);for(o in t.schemas)u.schema(t.schemas[o]);for(i in t.models)u.model(t.models[i]);for(s in u.create(),t.behaviors)f._Behavior.insert(t.behaviors[s]);for(n in y.initDb(),t.components)for(a in t.components[n])f[n].insert(t.components[n][a]);(d=f._System.find({master:!0})).length&&(d[0][g.ID]===t[g.ID]?t.master=!0:t.master&&(d[0].master=!1)),f._System.insert(t),e=t[g.ID]}return e},f.exportSystem=function(e){return e?function(e){var t,n,a,r,o,i={},s=[],d="",c=0,l=0,u="";if((s=f._System.find({master:!0})).length&&(d=s[0].name),i.name=e.name||"sub_"+d,i.version=e.version||"0.0.1",i.description=e.description||"",i.schemas={},e.schemas)for(l=(s=f._Schema.find(e.schema)).length,c=0;c<l;c++)(t=s[c])[g.CORE]||(i.schemas[t[g.ID]]=t);if(i.models={},e.models)for(l=(s=f._Model.find(e.models)).length,c=0;c<l;c++)(a=s[c])[g.CORE]||(i.models[a[g.ID]]=a);if(i.types={},e.types)for(l=(s=f._Type.find(e.types)).length,c=0;c<l;c++)(n=s[c])[g.CORE]||(i.types[n[g.ID]]=n);if(i.behaviors={},e.behaviors)for(f._Behavior.find(e.behaviors),l=s.length,c=0;c<l;c++)(r=s[c]).core||(i.behaviors[r[g.ID]]=r);if(i.components={},e.components)for(u in e.components)if(f[u])for(i.components[u]={},l=(s=f[u].find(e.components[u])).length,c=0;c<l;c++)o=s[c],i.components[u][o[g.ID]]=o;return JSON.stringify(i)}(e):d()},f.clear=function(){for(var e=0,t=0,n="",e=v.length,t=0;t<e;t++)n=v[t],f[n].remove();for(e=r.length,t=0;t<e;t++)f[n=r[t]].remove()},f.init=function(){var e=f._System.find({_id:"e89c617b6b15d24"})[0];f.clear(),l.clear(),u.clear(),a.clear(),n.clear(),p.clear(),u.init(),e=f.importSystem(e),l.get(e).start()}},{"./behavior.js":2,"./component.js":3,"./helper.js":5,"./history.js":6,"./log.js":7,"./metamodel.js":8,"./mson.js":9,"./state.js":11,"./workflow.js":12}],5:[function(require,module,exports){!function(global){!function(){"use strict";var $db=require("./db.js"),$component=require("./component.js"),$mson=require("./mson.js"),runtimeRef=null,requireRef=null;exports.isRuntime=function(){var e=!1;return e=$db._Runtime&&$db._Runtime.find().length?!0:e},exports.getRuntime=function(){var e=$db._Runtime.find();return!runtimeRef&&e[0]&&(e=e[0][$mson.ID],runtimeRef=$component.get(e)),runtimeRef},exports.isOnNode=function(){var e=!1;return e="undefined"==typeof window&&void 0!==global?!0:e},exports.getRequire=function getRequire(){return requireRef=requireRef||eval("require"),requireRef},exports.generateId=function(){return"abcdef".charAt(Math.floor(Math.random()*"abcdef".length))+"xxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(e){var t=16*Math.random()|0;return("x"===e?t:3&t|8).toString(16)})},exports.polyfill=function(){void 0===Function.prototype.name&&void 0!==Object.defineProperty&&Object.defineProperty(Function.prototype,"name",{get:function(){var e=/function\s([^(]{1,})\(/.exec(this.toString());return e&&1<e.length?e[1].trim():""},set:function(e){}})}}.call(this)}.call(this,"undefined"!=typeof global?global:"undefined"!=typeof self?self:"undefined"!=typeof window?window:{})},{"./component.js":3,"./db.js":4,"./mson.js":9}],6:[function(e,t,n){"use strict";var a=e("./db.js"),r=e("./log.js"),o=[],i=-1,s=!1;n.isEnabled=function(){return s},n.start=function(){s=!0},n.stop=function(){s=!1},n.pushState=function(e){o.push(e)},n.state=function e(){return e[e.length-1]},n.back=function(){var e=o[i],t={};if(e){switch(e.action){case"insert":a[e.collection].remove({_id:e.id}),r.historyDocumentRemoved(e.id,e.collection);break;case"remove":a[e.collection].insert(JSON.parse(e.oldValue)),r.historyDocumentInserted(e.id,e.collection,e.oldValue);break;case"update":t[e.field]=JSON.parse(e.oldValue),a[e.collection].update({_id:e.id},t),r.historyDocumentUpdated(e.id,e.collection,e.field,e.oldValue)}i-=1}return i},n.forward=function(){var e=o[i+=1],t={};if(e)switch(e.action){case"insert":a[e.collection].insert(JSON.parse(e.value)),r.historyDocumentInserted(e.id,e.collection,e.value);break;case"remove":a[e.collection].remove({_id:e.id}),r.historyDocumentRemoved(e.id,e.collection);break;case"update":t[e.field]=JSON.parse(e.value),a[e.collection].update({_id:e.id},t),r.historyDocumentUpdated(e.id,e.collection,e.field,e.value)}return i},n.get=function(e){return e<0?o[o.length+e]:o[e]},n.from=function(e){i=-1===e?o.length-1:e},n.dump=function(){return JSON.stringify({stack:o})},n.load=function(e){var t=!0;try{var n={};("string"==typeof e?JSON.parse(e):e).stack.forEach(function(e){if(e)switch(e.action){case"insert":a[e.collection]?(a[e.collection].insert(JSON.parse(e.value)),r.historyDocumentInserted(e.id,e.collection,e.value)):t=!1;break;case"remove":a[e.collection]?(a[e.collection].remove({_id:e.id}),r.historyDocumentRemoved(e.id,e.collection)):t=!1;break;case"update":a[e.collection]?(n[e.field]=JSON.parse(e.value),a[e.collection].update({_id:e.id},n),r.historyDocumentUpdated(e.id,e.collection,e.field,e.value)):t=!1}})}catch(e){t=!1}return t},n.clear=function(){o=[]}},{"./db.js":4,"./log.js":7}],7:[function(e,t,n){"use strict";var a=e("./metamodel.js"),r=e("./db.js"),o=e("./component.js"),i=e("./mson.js"),s={currentLevel:"warn",level:function(e){return e&&(this.currentLevel=e),this.currentLevel},debug:function(e){"debug"===this.currentLevel&&console.log("runtime: "+e)},info:function(e){"info"!==this.currentLevel&&"debug"!==this.currentLevel||console.info("runtime: "+e)},warn:function(e){"info"!==this.currentLevel&&"warn"!==this.currentLevel&&"debug"!==this.currentLevel||console.warn("runtime: "+e)},error:function(e){"info"!==this.currentLevel&&"warn"!==this.currentLevel&&"debug"!==this.currentLevel&&"error"!==this.currentLevel||console.error("runtime: "+e)}};function d(){var e;return a.getModel("_Logger")&&(e=r._Logger.find()).length&&(e=e[0][i.ID],o.get(e))?o.get(e):s}n.level=function(e){0},n.unknownProperty=function(e,t){var n="",n=t[i.NAME]?"unknown property '"+e+"' for the definition of '"+t[i.NAME]+"'":"unknown property '"+e+"' for a model";d().warn(n)},n.invalidPropertyType=function(e,t,n){n=n&&n.constructor?n.constructor.name:typeof n;d().warn("invalid value for property '"+e+"': expected type '"+t+"' instead of type '"+n+"'")},n.invalidEnumValue=function(e,t){d().warn("'"+e+"' is an invalid value for the type enum '"+t+"'")},n.invalidClassName=function(e,t,n){d().warn("invalid component '"+e+"' for a collection: expected a component of class '"+t+"' instead of '"+n+"'")},n.missingProperty=function(e){d().warn("property '"+e+"' is missing")},n.missingImplementation=function(e){d().warn("schema '"+e+"' is missing")},n.invalidTypeImp=function(e,t){d().error("the property '"+e+"' of "+t+" model is invalid")},n.missingPropertyImp=function(e,t){d().warn("missing property '"+e+"' in the model '"+t+"'")},n.unknownPropertyImp=function(e,t){d().error("the model '"+t+"' has an unknown property '"+e+"'")},n.invalidTypeDefinition=function(e){d().warn("the type '"+e+"' is not valid")},n.invalidPropertyName=function(e,t,n,a,r){var o="",i="";"Function"!==t&&(o=" ("+t+" class)"),"string"==typeof r?(i=a&&a.constructor?a.constructor.name:typeof a,d().warn("invalid value for property '"+n+"' on component '"+e+"'"+o+": expected type '"+r+"' instead of type '"+i+"'")):(i=r&&r.constructor?r.constructor.name:typeof r,d().warn("invalid value for property '"+n+"' on component '"+o+": expected type 'string' instead of type '"+i+"'"))},n.readOnlyProperty=function(e,t,n){t="Function"!==t?" ("+t+" class)":"";d().warn("can not set read-only property '"+n+"' on component '"+e+"'"+t)},n.invalidDocumentOnDbInsert=function(e,t){d().warn("invalid document '"+JSON.stringify(e).replace(/,/g,", ")+"' ("+t+" collection)")},n.invalidPropertyTypeOnDbUpdate=function(e,t,n,a,r){d().warn("invalid type for the property '"+n+"' of the document '"+t+"' ("+e+" collection) with the value '"+JSON.stringify(a)+"': expected type '"+r+"'")},n.unknownPropertyOnDbUpdate=function(e,t,n){d().warn("unknown property '"+e+"' for document '"+n+"' ("+t+" collection)")},n.unknownMethod=function(e,t){d().warn("try to call an unknown action '"+t+"' for the class '"+e+"'")},n.invalidCollectionName=function(e){d().warn("invalid name for the collection '"+e+"': there is no schema '"+e+"'")},n.invalidResultType=function(e,t,n,a,r){t="Function"!==t?" ("+t+" class)":"";d().warn("invalid type for the result of action '"+n+"' on component '"+e+"'"+t+": expected type '"+a+"' instead of type '"+r+"'")},n.unknownComponent=function(e,t){d().warn("unkown class name '"+e+"' for component '"+t+"'")},n.invalidParamNumber=function(e,t,n){t="Function"!==t?" ("+t+" class)":"";d().warn("invalid number of parameters when calling the action '"+n+"' on component '"+e+"'"+t)},n.invalidParamType=function(e,t,n,a){t="Function"!==t?" ("+t+" class)":"";void 0!==a?d().warn("invalid type for the parameter '"+a+"' when calling the action '"+n+"' on component '"+e+"'"+t):d().warn("invalid type for a parameter when calling the action '"+n+"' on component '"+e+"'"+t)},n.behaviorNotUnique=function(e,t){d().warn("try to add more than one action for the state '"+t+"' on class '"+e+"'")},n.invalidStateOn=function(e,t){d().warn("try to add an action to an unkwown state '"+t+"' on class '"+e+"'")},n.invalidStateOff=function(e,t){d().warn("try to remove an action from an unkwown state '"+t+"' on class '"+e+"'")},n.masterSystemNotFound=function(){d().warn("can not export the database because no system was defined")},n.invalidType=function(e,t,n){t=e&&t.constructor?t.constructor.name:typeof t;d().warn("invalid value for property '"+e+"': expected type '"+n+"' instead of type '"+t+"'")},n.invalidConfiguration=function(e,t){d().warn("invalid type for '"+JSON.stringify(e)+"': expected '"+t+"'")},n.unknownType=function(e){d().warn("unknown type for value '"+JSON.stringify(e)+"'")},n.unknownPath=function(e,t){d().warn("the path '"+e+"' has an unkown subpath '"+t+"'")},n.canNotYetValidate=function(e,t){d().debug("can not yet validate if the document '"+e+"' is compliant with "+t+" model")},n.invalidChannelEvent=function(e,t,n){d().warn("invalid type for the message '"+JSON.stringify(e)+"': expected type '"+n+"' for event '"+t+"'")},n.invalidParamNumberMethodOn=function(e,t,n){t="Function"!==t?" ("+t+" class)":"";d().warn("invalid number of parameters when adding an action for the state '"+n+"' on component '"+e+"'"+t)},n.updateUuid=function(e,t,n){n?d().warn("try to update a component of id '"+e+"' with the new id '"+t+"' that is already used"):d().warn("try to update a component of id '"+e+"' with the new id '"+t+"'")},n.invalidUseOfComponent=function(e){d().warn("try to change the state of the destroyed component '"+e+"'")},n.invalidSchema=function(e){d().warn("the schema '"+e+"' is not valid, it has been removed from the metamodel")},n.invalidModel=function(e){d().warn("the model '"+e+"' is not valid, it has been removed from the metamodel")},n.invalidParameters=function(e,t){t=t&&t._id?t._id:"";d().warn("the parameters for creating '"+t+"' component ("+e+" model) are not compliant with the model")},n.destroyedComponentCall=function(e,t){d().warn("trying to get the property '"+e+"' on the destroyed component '"+t+"'")},n.invalidConctructorParameters=function(e,t){d().warn("the constructor parameter '"+JSON.stringify(e).replace(/,/g,", ")+"' for creating a component of class '"+t+"' is not an object")},n.unknownModel=function(e){d().warn("the model '"+e+"' does not exist")},n.missingSchema=function(e){d().warn("the schema '"+e+"' is missing")},n.cyclicDependency=function(e){e?d().error("a cyclic inheritance dependency with the schema '"+e+"’ has been found, please check the '_inherit' property of this schema"):d().error("a cyclic inheritance dependency has been found, please check the '_inherit' properties of the schemas")},n.invalidEnumType=function(e,t,n){void 0!==n&&n!==typeof e?(e=e&&e.constructor?e.constructor.name:typeof e,d().warn("invalid type for the type '"+t+"': expected type '"+n+"' instead of type '"+e+"'")):d().warn("invalid type for the type '"+t+"'")},n.loadSchema=function(e){d().debug("load schema '"+e+"'")},n.loadModel=function(e){d().debug("load model '"+e+"'")},n.loadType=function(e){d().debug("load type '"+e+"'")},n.generatingSchema=function(e){d().debug("generating "+e+" schema ...")},n.checkModel=function(e){d().debug("analyzing "+e+" model...")},n.createClass=function(e){d().debug(e+" class has been created")},n.initDb=function(){d().debug("initializing data store...")},n.actionInvokeError=function(e,t,n,a){"Function"!==n?d().error("error when calling the action '"+e+"' on component '"+t+"' ("+n+" class): "+a):d().error("error when calling the action '"+e+"' on component '"+t+"': "+a)},n.invalidSchemaPropertyName=function(e,t){d().warn("invalid name '"+t+"' for schema '"+e+"': a property name can not begin with '_'")},n.invalidSchemaProperty=function(e,t){d().warn("invalid property '"+t+"' for schema '"+e+"': only 'property', 'link', 'collection', 'method' and 'event' are allowed")},n.invalidPropertyFormat=function(e){d().warn("invalid format for a definition of a property: '"+e+"' is not an object")},n.invalidState=function(e,t){d().warn("invalid state '"+t+"' for the model '"+e+"'")},n.unknownContext=function(e,t){d().warn("invoke the action '"+t+"' on the class '"+e+"' without a valid context")},n.historyDocumentInserted=function(e,t,n){d().debug("Created component of id '"+e+"' ('"+t+" collection) with document '"+n+"'")},n.historyDocumentRemoved=function(e,t){d().debug("Destroyed component of id '"+e+"' ("+t+" collection)")},n.historyDocumentUpdated=function(e,t,n,a){d().debug("Updated field '"+n+"' of component of id '"+e+"' with value '"+a+"' ("+t+" collection)")},n.invalidCollectionItem=function(e,t,n,a,r){t="Function"!==t?" ("+t+" class)":"";d().warn("invalid value for property '"+n+"' on component '"+e+"'"+t+": expected type '"+r+"' for all items of the collection '"+JSON.stringify(a)+"'")}},{"./component.js":3,"./db.js":4,"./metamodel.js":8,"./mson.js":9}],8:[function(e,t,g){"use strict";var b=e("./db.js"),_=e("./log.js"),O=e("./component.js"),s=e("./helper.js"),S=e("./mson.js"),I={inheritance:{},inheritanceTree:{},schemas:{},generatedSchemas:{},models:{},generatedModels:{},states:{},type:{}};function v(e){var t=!0;return t=-1===S.INTERNAL_NAMES.indexOf(e)?!1:t}function N(){var e,t,n,a,r,o,i,s="",d="",c="",l="",u=null,m={},y={},f=[],p=0,h=0;for(c in I.generatedSchemas){for(s in m={_name:(e=I.generatedSchemas[c])[S.NAME]},void 0!==e[S.CORE]&&(m[S.CORE]=e[S.CORE]),Array.isArray(e[S.INHERIT])&&(m[S.INHERIT]=e[S.INHERIT]),void 0!==e[S.CLASS]&&(m[S.CLASS]=e[S.CLASS]),void 0!==e[S.DESCRIPTION]&&(m[S.DESCRIPTION]=e[S.DESCRIPTION]),e)v(s)||0!==s.indexOf("_")||_.invalidSchemaPropertyName(e[S.NAME],s);for(s in e)switch(!0){case"property"===e[s]:m[s]={type:"any",readOnly:!1,mandatory:!1,default:"",description:s,label:s};break;case"link"===e[s]:m[s]={type:"_Component",readOnly:!1,mandatory:!1,default:"",description:s,label:s};break;case"method"===e[s]:m[s]={params:[{name:"param1",type:"any",mandatory:!1,default:null},{name:"param2",type:"any",mandatory:!1,default:null},{name:"param3",type:"any",mandatory:!1,default:null}],result:"any",description:s};break;case"event"===e[s]:m[s]={params:[{name:"param1",type:"any",mandatory:!1,default:null},{name:"param2",type:"any",mandatory:!1,default:null},{name:"param3",type:"any",mandatory:!1,default:null}],description:s};break;case"collection"===e[s]:m[s]={type:["_Component"],readOnly:!1,mandatory:!1,default:[],description:s,label:s};break;default:v(s)||_.invalidSchemaProperty(e[S.NAME],s)}I.generatedModels[m[S.NAME]]=m}for(l in I.generatedModels)d=(m=I.generatedModels[l])[S.NAME],(u=I.models[d])&&(y=C(u,m),I.generatedModels[d]=y);for(o=(i=function(){var t=[],n={},e="",a=0;for(e in I.inheritanceTree)a=I.inheritanceTree[e].length,void 0===n[a]&&(n[a]=[]),n[a].push(e);return Object.keys(n).sort().forEach(function(e){n[e].forEach(function(e){t.push(e)})}),t}()).length,p=0;p<o;p++)if(l=i[p],m=I.generatedModels[l]){for((f=g.getParents(l)).reverse(),r=f.length,h=0;h<r;h++)d=f[h],(n=I.generatedModels[d])&&(y=C(n,m),I.generatedModels[l]=y);(u=I.models[l])&&(y=C(u,I.generatedModels[l]),I.generatedModels[l]=y)}for(c in I.generatedSchemas)t=I.generatedSchemas[c],b._GeneratedSchema.insert(t);for(l in I.generatedModels)a=I.generatedModels[l],b._GeneratedModel.insert(a)}function w(){var e="",t=[];function a(e){for(var t=0,n=[],a=e.length,t=0;t<a;t++)if(function(e,t){for(var n=!0,a=0,r=t.length,a=0;a<r;a++)0<t[a].indexOf(e)&&(n=!1);return n}(e[t][0],e)){n.push(e[t][0]),s=d=i=o=r=void 0;for(var r=e[t][0],o=e,i=0,s=[],d=o.length,i=0;i<d;i++)0===o[i].indexOf(r)&&((s=o[i]).reverse(),s.pop(),s.reverse(),o[i]=s);break}return n}function s(e){for(var t=[],n=[],n=a(e);void 0!==n[0];)t=t.concat(n),n=a(e);return function(e){for(var t=0,n=!0,a=e.length,t=0;t<a;t++)e[t].length&&(n=!1);return n}(e)||_.cyclicDependency(),t}function d(e){var t,n,a,r,o=[],i=0;for(Array.isArray(I.inheritance[e])?o=I.inheritance[e].slice():_.missingSchema(e),t=o.length,i=0;i<t;i++)if(n=e,a=o[i],void 0,r=!1,Array.isArray(I.inheritance[a])&&-1!==I.inheritance[a].indexOf(n)&&(_.cyclicDependency(n),r=!0),r){o=[];break}return o.length?[e].concat(s(o.map(d).concat([o]))):[e]}for(e in I.inheritance)(t=d(e).reverse()).pop(),t.length&&(I.inheritanceTree[e]=t)}function k(){var e="";for(e in I.schemas)I.schemas[e][S.CORE]||_.generatingSchema(e),I.generatedSchemas[e]=function(e){var t,n={},a=I.schemas[e],r=I.inheritanceTree[e],o=0,i=0,s="";for(r&&(o=r.length,r.reverse()),i=0;i<o;i++)for(s in t=I.schemas[r[i]])0!==s.indexOf("_")&&(n[s]=t[s]);for(s in a)n[s]=a[s];return n}(e)}function x(){var e,t,n="";for(n in I.generatedModels)if(e=I.generatedModels[n])if(t=I.generatedSchemas[n]){e[S.CORE]||_.checkModel(n),o=r=a=void 0;var a=e,r=t,o="";for(o in r)o!==S.ID&&o!==S.NAME&&o!==S.DESCRIPTION&&o!==S.INHERIT&&o!==S.CLASS&&o!==S.CORE&&(void 0!==a[o]?function(e,t){var n=!0;n=(j(t,"string")&&-1!==S.DEFAULT_TYPES.indexOf(t)?j:d)(e,t);return n}(a[o],r[o])||_.invalidTypeImp(o,a[S.NAME]):_.missingPropertyImp(o,a[S.NAME]));for(o in a)o!==S.ID&&o!==S.NAME&&o!==S.DESCRIPTION&&o!==S.INHERIT&&o!==S.CLASS&&o!==S.CORE&&void 0===r[o]&&_.unknownPropertyImp(o,a[S.NAME])}else _.missingImplementation(n)}function d(e,t){var n,a=!0,r=I.type[t],o=0;if(j(r,"undefined"))a=!1;else if(j(e,"undefined"))a=!1;else if("array"===r.type)for(n=e.length,o=0;o<n&&!1!==(a=j(r.schema,"undefined")?g.isValidType(e[o],r.type):g.isValidSchema(e[o],r.schema));o++);else a=j(r.schema,"undefined")?g.isValidType(e,r.type):g.isValidSchema(e,r.schema);return a}function p(e){return e.trim()}function h(e){return j(e,"string")&&-1===S.DEFAULT_TYPES.indexOf(e)&&!g.isClassName(e)}function E(e){var t="",t=Array.isArray(e)?"array":typeof e;return t="any"===e?"any":t}function A(e){return e&&e.constructor?e.constructor.name:typeof e}function y(e,t){return-1!==t.indexOf(e)}function j(e,t){var n=!0,a=null;switch(t){case"array":n=Array.isArray(e);break;case"date":n="string"==typeof e?(a=new Date(e),!isNaN(a.getDate())):e instanceof Date;break;case"any":n=!0;break;default:n=t===typeof e}return n}function n(e,t,n){var a=!1,t=I.generatedModels[t];return a=(t=t&&t[S.NAME]?I.generatedSchemas[t[S.NAME]]:t)&&t[e.split(".")[0]]===n?!0:a}function C(e,t){var n="",a=t;for(n in e)e.hasOwnProperty(n)&&0!==n.indexOf("_")&&(a[n]=e[n]);return a}function r(e,t,n){var a,r=null,o="";switch(!0){case"=>"===e:break;case"string"==typeof t&&"boolean"===t:r=n?{name:e,type:"boolean",mandatory:!1,default:!1}:{type:"boolean",readOnly:!1,mandatory:!1,default:!1};break;case"string"==typeof t&&"string"===t:r=n?{name:e,type:"string",mandatory:!1,default:""}:{type:"string",readOnly:!1,mandatory:!1,default:""};break;case"string"==typeof t&&"number"===t:r=n?{name:e,type:"number",mandatory:!1,default:0}:{type:"number",readOnly:!1,mandatory:!1,default:0};break;case"string"==typeof t&&"object"===t:r=n?{name:e,type:"object",mandatory:!1,default:{}}:{type:"object",readOnly:!1,mandatory:!1,default:{}};break;case"string"==typeof t&&"array"===t:r=n?{name:e,type:"array",mandatory:!1,default:[]}:{type:"array",readOnly:!1,mandatory:!1,default:[]};break;case"string"==typeof t&&"date"===t:r=n?{name:e,type:"date",mandatory:!1,default:"1970-01-01T00:00:00.000Z"}:{type:"date",readOnly:!1,mandatory:!1,default:"1970-01-01T00:00:00.000Z"};break;case"string"==typeof t&&"any"===t:r=n?{name:e,type:"any",mandatory:!1,default:null}:{type:"any",readOnly:!1,mandatory:!1,default:""};break;case"string"==typeof t:o={},(a=b._Type.find({name:t})).length&&a[0].value&&(o=a[0].value[0]),b._Schema.find({_name:t}).length&&(o=""),r=n?{name:e,type:t,mandatory:!1,default:o}:{type:t,readOnly:!1,mandatory:!1,default:o};break;case Array.isArray(t)&&"boolean"===t[0]:r=n?{name:e,type:["boolean"],mandatory:!1,default:[]}:{type:["boolean"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t)&&"string"===t[0]:r=n?{name:e,type:["string"],mandatory:!1,default:""}:{type:["string"],readOnly:!1,mandatory:!1,default:""};break;case Array.isArray(t)&&"number"===t[0]:r=n?{name:e,type:["number"],mandatory:!1,default:[]}:{type:["number"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t)&&"object"===t[0]:r=n?{name:e,type:["object"],mandatory:!1,default:[]}:{type:["object"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t)&&"date"===t[0]:r=n?{name:e,type:["date"],mandatory:!1,default:[]}:{type:["date"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t)&&"any"===t[0]:r=n?{name:e,type:["any"],mandatory:!1,default:[]}:{type:["any"],readOnly:!1,mandatory:!1,default:[]};break;case Array.isArray(t):r=n?{name:e,type:t,mandatory:!1,default:[]}:{type:t,readOnly:!1,mandatory:!1,default:[]}}return r}function o(e){var t="",n="",a={};for(t in e=JSON.parse(JSON.stringify(e)))if(e.hasOwnProperty(t)&&0!==t.indexOf("_"))switch(!0){case"string"==typeof e[t]||Array.isArray(e[t]):e[t]=r(t,e[t],!1);break;case"object"==typeof e[t]&&void 0===e[t]["=>"]:e[t]=C(e[t],r(t,e[t].type||"any"));break;case"object"==typeof e[t]&&void 0!==e[t]["=>"]:for(n in a={params:[],result:"any"},e[t])"string"==typeof e[t][n]&&("=>"===n?a.result=e[t][n]:a.params.push(r(n,e[t][n],!0))),"object"==typeof e[t][n]&&a.params.push(C(e[t][n]),r(n,e[t][n].type||"any"));e[t]=a}return e}g.schema=function(e,t){var n,a,r,o=null,i="";return i=void 0===t||0===Object.keys(t).length?"string"==typeof e?(t={})[S.NAME]=e:(t=JSON.parse(JSON.stringify(e)))[S.NAME]:((t=JSON.parse(JSON.stringify(t)))[S.NAME]=e,t[S.NAME]),void 0===t[S.ID]&&(t[S.ID]=s.generateId()),void 0===t[S.INHERIT]&&(t[S.INHERIT]=["_Component"]),t[S.INHERIT]=(e=t[S.INHERIT],a=[],r={},e.forEach(function(e){e=e.trim();void 0===r[e]&&a.push(r[e]=e)}),a),g.isValidObject(t,S.SCHEMA_DEFINITION,!1)?o=(e=b._Schema.find({_name:i})).length?(n=C(t,e[0]),b._Schema.update({_name:i},n),e[0][S.ID]):b._Schema.insert(t)[0]:_.invalidSchema(t[S.NAME]),o},g.model=function(e,t){var n,a=null,r="",r=(t=void 0===t||0===Object.keys(t).length?JSON.parse(JSON.stringify(e)):((t=JSON.parse(JSON.stringify(t)))[S.NAME]=e,o(t)))[S.NAME];return void 0===t[S.ID]&&(t[S.ID]=s.generateId()),g.isValidObject(t,S.MODEL_DEFINITION,!1)?a=(e=b._Model.find({_name:r})).length?(n=C(t,e[0]),b._Model.update({_name:r},n),e[0][S.ID]):b._Model.insert(t)[0]:_.invalidModel(t[S.NAME]),a},g.type=function(e,t){var n=null,a="",r={},a=(void 0===t||0===Object.keys(t).length?r=JSON.parse(JSON.stringify(e)):(Array.isArray(t)?(t=JSON.parse(JSON.stringify(t)),r.value=t,r.name=e,r.type=typeof t[0]||"any"):(t=JSON.parse(JSON.stringify(t)),r.schema=o(t),r.name=e,r.type="object"),r)).name;return void 0===r[S.ID]&&(r[S.ID]=s.generateId()),g.isValidObject(r,S.TYPE_DEFINITION)?n=b._Type.insert(r)[0]:_.invalidTypeDefinition(a),n},g.init=function(){g.clear(),b.collection("_Logger"),b.collection("_Schema"),b.collection("_GeneratedSchema"),b.collection("_Model"),b.collection("_GeneratedModel"),b.collection("_Behavior"),b.collection("_Type"),b.collection("_Message"),b.collection("_Channel"),b.collection("_History")},g.clear=function(){I={inheritance:{},inheritanceTree:{},schemas:{},generatedSchemas:{},models:{},generatedModels:{},states:{},type:{}}},g.create=function(){var e,t,n,a,r,o,i,s="",d=0,c=0;for(I.inheritance={},I.inheritanceTree={},I.schemas={},I.generatedSchemas={},I.models={},I.generatedModels={},I.states={},I.type={},c=(e=b._Schema.find({})).length,d=0;d<c;d++)s=(n=e[d])[S.NAME],i=n[S.INHERIT],I.schemas[s]=n,i&&(I.inheritance[s]=i),n[S.CORE]||_.loadSchema(s);for(c=(r=b._Model.find({})).length,d=0;d<c;d++)s=(a=r[d])[S.NAME],(I.models[s]=a)[S.CORE]||_.loadModel(s);for(c=(t=b._Type.find({})).length,d=0;d<c;d++)o=t[d],(I.type[o.name]=o).core||_.loadType(o.name);w(),k(),N(),x();var l,u,m="",y=[],f="";for(m in I.generatedSchemas){if(y=[],l=I.generatedSchemas[m])for(f in l)u=l[f],0!==f.indexOf("_")&&-1!==S.INTERNAL_TYPES.indexOf(u)&&y.push(f);I.states[m]=y}var p,h="";for(h in I.generatedModels)p=I.generatedModels[h],void 0===b[p[S.NAME]]&&!1!==p[S.CLASS]&&b.collection(p[S.NAME]);var g,v="";for(v in I.generatedModels)!1!==(g=I.generatedModels[v])[S.CLASS]&&(O.create({model:v}),g[S.CORE]||_.createClass(v))},g.isEvent=function(e,t){return n(e,t,S.EVENT_TYPE)},g.isProperty=function(e,t){return n(e,t,S.PROPERTY_TYPE)},g.isLink=function(e,t){return n(e,t,S.LINK_TYPE)},g.isCollection=function(e,t){return n(e,t,S.COLLECTION_TYPE)},g.isMethod=function(e,t){return n(e,t,S.METHOD_TYPE)},g.isStructure=function(e,t){var n=!1,a=null,t=g.getModelPathType(t,e);return n=(a=Array.isArray(a)?g.getType(t[0]):g.getType(t))&&a.schema?!0:n},g.isValidState=function(e,t){var n=!1,a=I.generatedModels[t],r={};return-1!==e.indexOf(".")?n=g.isValidModelPath(t,e):(a&&a[S.NAME]&&(a=I.generatedModels[a[S.NAME]]),r=I.states[a[S.NAME]],Array.isArray(r)&&(n=-1!==r.indexOf(e))),n},g.isValidType=function(e,t,n){var a,r,o,i,s=!0;switch(!0){case h(t):(s=d(e,t))||(I.type[t]?_.invalidEnumType(e,t,I.type[t].type):_.invalidEnumType(e,t)),s&&(a=e,r=t,o=I.type[r],!(i=!0)===(i=Array.isArray(o.value)&&-1===o.value.indexOf(a)?!1:i)&&_.invalidEnumValue(a,r),s=i);break;case g.isClassName(t):n||(null!==e&&"string"!=typeof e?s=g.inheritFrom(A(e),t):null!==e&&(s=!1));break;default:s=function(e,t,n){var a,r=!0,o=0;switch(E(t)){case"string":r=j(e,t);break;case"array":if(Array.isArray(e))for(a=e.length,o=0;o<a;o++)switch(!0){case h(t[0]):r=d(e[o],t[0]);break;case g.isClassName(t[0]):n?r=!1:""!==e[o]&&null!==e[o]&&"string"!=typeof e[o]&&(r=g.inheritFrom(A(e[o]),t[0]));break;default:r=j(e[o],t[0])}else r=!1}return r}(e,t,n)}return s},g.isValidEnum=function(e,t){var n,a,r,o=!0;return g.isClassName(t.type)?(n=O.get(e),a=p(t.type),r="",(o=(r="Function"===(r=n.constructor.name)?n.name:r)===a&&-1!==t.value.indexOf(e))||_.invalidEnumValue(e,t.type)):(o=j(e,t.type)&&-1!==t.value.indexOf(e))||_.invalidEnumValue(e,t.name),o},g.isValidSchema=function n(a,e){var t,r,o="",i=null,s=!0,d="",c="",l="",u=0,m=0;if(j(a,"object")){for(o in a){if(i=a[o],j(e[o],"undefined"))return _.unknownProperty(o,e),!1;switch(d=e[o].type,!0){case g.isClassName(d):s=s&&(r=!(t=void 0),c=A(d),h(c=a[c])?I.type[c]?I.type[c].schema?r=n(i,I.type[c].schema):(r=j(i,I.type[c].type),(t=I.type[c].value)&&(r=y(i,t))):r=!1:r="array"===c?Array.isArray(i):g.isClassName(c)?j(i,"object")||j(i,"string"):j(i,c),r||_.invalidPropertyType(o,c,i),r);break;case-1!==d.indexOf("{"):s=s&&function(){var e,t=!0;switch(c=d.replace("{","").replace("}","").trim(),!0){case"string"==typeof(c=a[c]):h(c)?I.type[c]?I.type[c].schema?t=n(i,I.type[c].schema):(t=j(i,I.type[c].type),(e=I.type[c].value)&&(t=y(i,e))):t=!1:t="array"===c?Array.isArray(i):g.isClassName(c)?j(i,"object")||j(i,"string"):j(i,c);break;case Array.isArray(c):Array.isArray(i)||(t=!1);break;default:t=!1}return t||_.invalidPropertyType(o,c,i),t}();break;default:s=s&&function(){var e=!0;switch(l=E(d)){case"string":if(h(l))e=n(i,d);else if(!j(i,d)){_.invalidPropertyType(o,d,i),e=!1;break}break;case"array":if(Array.isArray(i)){for(u=i.length,m=0;m<u;m++)if(h(d[0]))e=n(i[m],I.type[d[0]].schema);else if(!j(i[m],d[0])){_.invalidPropertyType(o,d[0],i[m]),e=!1;break}}else e=!1}return e}()}if(!s)break}for(o in e)if(!0===(i=e[o]).mandatory&&j(a[o],"undefined")&&void 0!==a[o]){_.missingProperty(o),s=!1;break}}else s=!1,_.invalidPropertyFormat(a);return s},g.isValidObject=function o(i,e,s,d){var t,c="",n=null,a=!0,r="",l="",u="",m=0,y=0;function f(e,t){var n,a=!0;if(n=I.type[t])switch(!0){case!j(n.schema,"undefined"):a=o(e,n.schema,s,d);break;case!j(n.value,"undefined"):a=g.isValidEnum(e,n);break;default:a=g.isValidType(e,n.type)}else a=!1;return a}for(c in j(s,"undefined")&&(s=!0),j(d,"undefined")&&(d=!1),j(i,"object")||(a=!1,_.invalidConfiguration(i,"object")),i)if(n=i[c],j(e[c],"undefined")&&c!==S.CORE&&c!==S.ID){if(s)return _.unknownProperty(c,e),!1}else{switch(!0){case c===S.CORE:r="boolean";break;case c===S.ID:r="string";break;default:r=e[c].type}switch(!0){case h(r):a=a&&f(n,r);break;case g.isClassName(r):a=a&&function(e,t){var n=!0,a=null,r=!1;if(l=p(t),e&&e.id?(a=e,r=!0):a=O.get(e),j(a,"undefined"))switch(!0){case j(e,"object")&&null!==e&&0<Object.keys(e).length:case j(e,"string")&&""!==e:}else g.inheritFrom(a.constructor.name,l)?r&&d&&(i[c]=a.id()):(n=!1,_.invalidType(c,e,l));return n}(n,r);break;default:a=a&&function(e,t){var n,a=!0,r=null;switch(u=E(t)){case"any":break;case"string":if(h(u))a=o(e,t,s,d);else if("array"===t){if("array"!==E(e)){_.invalidPropertyType(c,t,e),a=!1;break}}else if("date"===t){if(r=new Date(e),!(a=!isNaN(r.getDate()))){_.invalidPropertyType(c,t,e);break}}else if(E(e)!==t&&"any"!==E(e)){_.invalidPropertyType(c,t,e),a=!1;break}break;case"array":if(Array.isArray(e)){for(m=e.length,n=t[0],y=0;y<m;y++)if(h(n))a=f(e[y],n);else if(g.isClassName(n))if("string"===E(e[y]))if(O.get(e[y])){if(!g.inheritFrom(A(O.get(e[y])),p(n))){_.invalidClassName(JSON.stringify(e[y]),p(n),A(O.get(e[y]))),a=!1;break}}else e[y];else{if(!g.inheritFrom(A(e[y]),p(n))){_.invalidClassName(JSON.stringify(e[y]),p(n),A(e[y])),a=!1;break}d&&(e[y]=e[y].id())}else if(E(e[y])!==n&&"any"!==n){_.invalidPropertyType(c,n,e[y]),a=!1;break}}else a=!1,_.invalidType(c,e,"array");break;default:a=!1,_.unknownType(e)}return a}(n,r)}}for(c in e)t=(n=e[c]).mandatory,i&&j(i[c],"undefined")&&!0===t&&(_.missingProperty(c),a=!1);return a},g.prepareObject=function(e,t){var n,a,r="";for(r in t=JSON.parse(JSON.stringify(t)))n=(a=t[r]).mandatory,a=a.default,!j(e[r],"undefined")||!1!==n||j(a,"undefined")||(e[r]=a)},g.getSchema=function(e){var t=null;return t=I.generatedSchemas[e]?I.generatedSchemas[e]:t},g.getModel=function(e){var t=null;return t=I.generatedModels[e]?I.generatedModels[e]:t},g.getType=function(e){var t=null;return t=I.type[e]&&I.type[e]?JSON.parse(JSON.stringify(I.type[e])):t},g.getModelPathType=function(e,t){for(var n,a,r=null,o="",i=0,s=(a=t.split(".")).length,i=0;i<s;i++)if(o=(o=a[i]).split("[")[0],0===i)r=g.getModel(e)[o].type;else if(h(r=Array.isArray(r)?r[0]:r))switch(!0){case void 0!==(n=g.getType(r)).schema:n.schema[o]?r=n.schema[o].type:_.unknownPath(t,o);break;case void 0!==n.type:r=n.type;break;default:_.invalidState(e,t)}return r},g.isValidModelPath=function(e,t){for(var n,a,r=!0,o=null,i="",s=0,d=(a=t.split(".")).length,s=0;s<d;s++)i=(i=a[s]).split("[")[0],0===s?(o=g.getModel(e)[i].type)||(r=!1):h(o=Array.isArray(r)?o[0]:o)&&(n=g.getType(o)).schema&&n.schema[i]&&((o=n.schema[i].type)||(r=!1));return r},g.getParents=function(e){return I.inheritanceTree[e]?I.inheritanceTree[e].slice():[]},g.inheritFrom=function(e,t){var n,a=!1,r=[],o=0;if(e!==t){if(n=(r=g.getParents(e)).length,0!==r.length)if(-1!==r.indexOf(t))a=!0;else for(o=0;o<n&&!(a=function e(t,n){var a=!1,r=[],o=0;if(0!==(r=g.getParents(t)).length)if(-1!==r.indexOf(n))a=!0;else for(o=0;o<0&&!(a=e(r[o],n));o++);return a}(r[o],t));o++);}else a=!0;return a},g.isClassName=function(e){var t=j(e,"string");return t=t&&0<Object.keys(I.generatedModels).length&&void 0!==I.generatedModels[e]}},{"./component.js":3,"./db.js":4,"./helper.js":5,"./log.js":7,"./mson.js":9}],9:[function(e,t,n){"use strict";n.ID="_id",n.NAME="_name",n.DESCRIPTION="_description",n.INHERIT="_inherit",n.CLASS="_class",n.CORE="_core",n.INTERNAL_NAMES=["_id","_name","_inherit","_description","_class","_core"],n.PROPERTY_TYPE="property",n.COLLECTION_TYPE="collection",n.LINK_TYPE="link",n.METHOD_TYPE="method",n.EVENT_TYPE="event",n.INTERNAL_TYPES=["property","collection","link","method","event"],n.DEFAULT_TYPES=["boolean","string","number","object","function","array","date","any"],n.SCHEMA_DEFINITION={_id:{type:"string",mandatory:!0},_name:{type:"string",mandatory:!0},_inherit:{type:["string"],mandatory:!1,default:["_Component"]},_class:{type:"boolean",mandatory:!1},_core:{type:"boolean",mandatory:!1},_description:{type:"string",mandatory:!1}},n.MODEL_DEFINITION={_id:{type:"string",mandatory:!0},_name:{type:"string",mandatory:!0},_inherit:{type:["string"],mandatory:!1},_class:{type:"boolean",mandatory:!1},_core:{type:"boolean",mandatory:!1},_description:{type:"string",mandatory:!1}},n.TYPE_DEFINITION={_id:{type:"string",mandatory:!0},name:{type:"string",mandatory:!0},type:{type:"string",mandatory:!0},schema:{type:"object",mandatory:!1},value:{type:["any"],mandatory:!1},core:{type:"boolean",mandatory:!1},description:{type:"string",mandatory:!1}}},{}],10:[function(e,t,n){"use strict";var a=e("./db.js"),r=e("./component.js"),o=e("./metamodel.js"),i=e("../build/system/system.js"),s="",d=null;e("./helper.js").polyfill(),o.init(),e=a.importSystem(i.system),s=r.get(e),d=r.get("channel"),s.state("installed"),d.$systemInstalled(e),s.state("resolved"),d.$systemResolved(e),s.state("starting"),d.$systemStarted(e),s.start(),s.state("active"),t.exports=r.get("runtime")},{"../build/system/system.js":1,"./component.js":3,"./db.js":4,"./helper.js":5,"./metamodel.js":8}],11:[function(e,t,n){"use strict";var a={};n.set=function(e,t,n){a[e]={state:t,value:n}},n.get=function(e){return a[e]},n.clear=function(){a={}}},{}],12:[function(e,t,f){"use strict";var p=e("./metamodel.js"),h=e("./component.js"),g=e("./behavior.js"),v=e("./state.js"),l=e("./helper.js"),b=e("./log.js"),_=e("./db.js"),u=e("./history.js");function m(e){this.message=e,this.name="RuntimeError"}function O(e){return-1!==e.indexOf(".")}function S(e,t){var n,a,r=null,o=[],i=0,s=0,d=0;if(p.getModel(e)?r=p.getModel(e)[t]:b.unknownModel(e),r){if(n=r.params)for(a=n.length,i=0;i<a;i++)void 0!==n[i].mandatory&&!0!==n[i].mandatory||(s+=1),d+=1;o.push(s),o.push(d)}else-1===t.indexOf("[")&&-1===t.indexOf(".")&&b.unknownMethod(e,t);return o}function I(t,n,e,a,r){var o,i=null,s=[],d="",c=0,d=("Function"===t.constructor.name?t:t.constructor).name;p.isProperty(n,d)||p.isLink(n,d)||p.isCollection(n,d)||(a=function(e,t,n){var a,r,o,i=[],s=0;if(o=p.getModel(e)[t]){if(a=o.params)for(r=a.length,s=0;s<r;s++)!1===a[s].mandatory&&void 0===n[s]?i.push(a[s].default):i.push(n[s])}else-1===t.indexOf("[")?b.unknownMethod(e,t):i=n;return i}(d,n,a));try{for(o=a.length,c=0;c<o;c++)s.push(a[c]);e.useCoreAPI&&(s.push(h),s.push(_),s.push(p),s.push(f),s.push(g),s.push(v),s.push(b),s.push(l),s.push(u)),l.isOnNode()&&s.push(l.getRequire()),r?e.context?setTimeout(e.action.bind.apply(e.action,[e.context].concat(s)),0):setTimeout(e.action.bind.apply(e.action,[t].concat(s)),0):i=e.context?e.action.apply(e.context,s):e.action.apply(t,s)}catch(e){if(e instanceof m)throw e;t&&t.error&&t.error({message:"error when running the behavior '"+n+"' on component '"+t.id()+"'",stack:e}),l.getRuntime()&&(t&&l.getRuntime().system()&&l.getRuntime().system().id&&t.id()!==l.getRuntime().system().id()&&l.getRuntime().system().error({message:"error when running the behavior '"+n+"' on component '"+t.id()+"'",stack:e}),l.getRuntime().error({message:"error when running the behavior '"+n+"' on component '"+t.id()+"'",stack:e})),b.actionInvokeError(n,t.id(),t.constructor.name,e.message)}return i}(m.prototype=new Error).constructor=m,f.checkInputNumbers=function(e,t,n){var a="",r="",o=[],i=[],s=!1,n=(a=n.toString()).indexOf("{"),a=(o=""===(o=(-1!==(r=(r=a.substring(0,n)).replace("=>","")).indexOf("(")?r.split("(")[1].replace(")",""):r).trim().split(","))[0]?[]:o).length,n=p.isProperty(t,e),r=p.isLink(t,e);switch(!0){case p.isCollection(t,e):i=[2,2];break;case n:i="array"===p.getModelPathType(e,t)?[2,2]:[1,1];break;case r:i=[1,1];break;default:i=S(e,t)}return s=i[0]<=a&&a<=i[1]?!0:s},f.checkInput=function(e){var t,n=(e=e||{}).component||null,a=e.methodName||"",r=e.args||"",o=[],i=[],s="",d=r.length,c=0,l=!0,s=("Function"===n.constructor.name?n:n.constructor).name,e=p.isProperty(a,s),u=p.isLink(a,s),m=p.isCollection(a,s),y=function(e,t){var n,a,r=null,o=[],i=0;if(p.getModel(e)?r=p.getModel(e)[t]:b.unknownModel(e),r){if(n=r.params)for(a=n.length,i=0;i<a;i++)o.push(n[i].name)}else O(t)||b.unknownMethod(e,t);return o}(s,a);switch(!0){case m&&-1===a.indexOf("."):o=r&&r[1]&&"reset"===r[1]?[[p.getModel(s)[a].type[0]],"string"]:[p.getModel(s)[a].type[0],"string"],i=[2,2];break;case e&&-1===a.indexOf("."):o=O(a)?[p.getModelPathType(s,a)]:[p.getModel(s)[a].type],i="array"===p.getModelPathType(s,a)?(o=r&&r[1]&&"reset"===r[1]?[["any"],"string"]:["any","string"],[2,2]):[1,1];break;case u&&-1===a.indexOf("."):o=[p.getModel(s)[a].type],i=[1,1];break;default:o=function(e,t){var n,a,r=null,o=[],i=0;if(p.getModel(e)?r=p.getModel(e)[t]:b.unknownModel(e),r){if(n=r.params)for(a=n.length,i=0;i<a;i++)o.push(n[i].type)}else-1===t.indexOf("[")&&-1===t.indexOf(".")&&b.unknownMethod(e,t);return o}(s,a),i=S(s,a)}for(((d=void 0===d?1:d)<i[0]||i[1]<d)&&(l=!1,b.invalidParamNumber(n.id(),n.constructor.name,a)),c=0;c<d;c++)void 0===(t=r[c])?c<i[0]&&(l=!1,b.invalidParamNumber(n.id(),n.constructor.name,a)):p.isValidType(t,o[c])||(l=!1,b.invalidParamType(n.id(),n.constructor.name,a,y[c]));return l},f.checkOutput=function(e){var t,n,a=(e=e||{}).component||null,r=e.methodName||"",o=null,i="",s=null,d=!0,o=void 0!==e.methodResult?e.methodResult:void 0,i=("Function"===a.constructor.name?a:a.constructor).name;return e=i,i=r,n=t=null,p.getModel(e)?t=p.getModel(e)[i].result:b.unknownModel(e),s=n=t||n,p.isValidType(o,s)||(d=!1,b.invalidResultType(a.id(),a.constructor.name,r,"string"==typeof s?s:JSON.stringify(s),Array.isArray(o)?"array":typeof o)),d},f.process=function(e){(e=e||{}).id=e.id||"",e.component=e.component||"",e.state=e.state||"",e.data=e.data||[],e.context=e.context||null;var t,n,a,r=null,o=[],i=void 0,s=0,d=!1,c=!1,l=!1,u=!1,m=!1,y=!1;if((a=v.get(e.component))&&"destroy"===a.state&&b.invalidUseOfComponent(e.component),e.id?0===(a=_._Behavior.find({_id:e.id})).length&&(a=a[0],r=h.get(a.component))&&(d=("Function"===r.constructor.name?r:r.constructor).name,c=p.isProperty(a.state,d),l=p.isLink(a.state,d),u=p.isCollection(a.state,d),m=p.isEvent(a.state,d),y=p.isMethod(a.state,d),n=g.get(e.id))&&(I={useCoreAPI:a.useCoreAPI,context:a.context,action:n},o.push(I)):(r=h.get(e.component))&&(d=("Function"===r.constructor.name?r:r.constructor).name,c=p.isProperty(e.state,d),l=p.isLink(e.state,d),u=p.isCollection(e.state,d),m=p.isEvent(e.state,d),y=p.isMethod(e.state,d),o=function e(t,n,a){var r,o,i,s=g.getActions(t.id(),n),d=0;if(!s.length||a)if("Function"!==t.constructor.name)s=s.concat(e(h.get(t.constructor.name),n,a));else for(o=(r=p.getParents(t.name)).length,d=0;d<o&&((i=h.get(r[d]))?s=s.concat(e(i,n,a)):b.unknownComponent(r[d],t.name),!s.length);d++);return s.length&&s.reverse(),s}(r,e.state,m)),o.length){if(f.checkInput({component:r,methodName:e.state,args:e.data}))if(y)i=I(e.context||r,e.state,o[0],e.data,!1),f.checkOutput({component:r,methodName:e.state,methodResult:i});else{for(t=o.length,s=0;s<t;s++)I(e.context||r,e.state,o[s],e.data,!0);v.set(r.id(),e.state,e.data)}}else r&&(m||c||l||u)&&v.set(r.id(),e.state,e.data);return i}},{"./behavior.js":2,"./component.js":3,"./db.js":4,"./helper.js":5,"./history.js":6,"./log.js":7,"./metamodel.js":8,"./state.js":11}]},{},[10])(10)});